<?php
	$autoSnapshotJson = array();
	if(file_exists('/unas/etc/zfs/autosnapshot.json')){
		$autoSnapshotJson = json_decode(file_get_contents('/unas/etc/zfs/autosnapshot.json'), true);
	}
	foreach($autoSnapshotJson as $vol => $value){
		if($value['Weekly'] == 'true'){
			$t = date('Y-m-d_His');
			//take a snapshot.
			exec("/usr/bin/sudo zfs snapshot " . $vol . "@weekly-" . $t, $output,$ret);
			if ($ret==0){
				//echo true;
			}else{
				//echo false;
			}
			//check if there are too many snapshots and delete extra copies
			$copies = $value['WeeklyCopies'];
			$output = [];
			exec("/usr/bin/sudo zfs list -rHp -t snapshot " . $vol ." -o name" ,$output, $ret); //get a list of snapshot.
			//find weekly snapshots
			$weeklySnapshot=array();
			for($i=0; $i<count($output); $i++){
				if (strpos($output[$i], '@weekly-') !== false) {
					$weeklySnapshot[]=$output[$i]; //add to array.
				}
			}
			$weeklySnapshot = array_reverse($weeklySnapshot); //sort
			$sz = count($weeklySnapshot);
			if($sz > $copies){
				for ($i =  $copies; $i < $sz; $i++){
					exec("/usr/bin/sudo zfs destroy " . $weeklySnapshot[$i], $output2, $ret2); 	//delete snapshot
				}
			}
			//exec("/usr/bin/sudo zfs list -rHp -t snapshot " . $vol ." -o name" ,$output3, $ret3); //get a list of snapshot.
			//rsort($output3);
			//echo print_r($output3,true);
		}
	}
?>