<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_get_pvsinfo(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    $zfs = \UNAS\Volume\Volume::CreateVolumeObject("zfs");

    $disks_info = \UNAS\Disk\GetAllDataDisksInformation();

    $listdisks_info = array();
    foreach($disks_info as $disk_info){
        $listdisks_info[] = [
            "device" => $disk_info['device'],
            "size" => $disk_info['size'],
            "model" => $disk_info['model'],
            "type" => $disk_info['type'],
            "state" => !\UNAS\Disk\IsDiskInUse($disk_info['device'])
        ];
    }

    $respond->results = $listdisks_info;
    $respond->err = ERR_SUCCEED;
    return true;
}
///---INTERFACE-METHODS---END---///

?>
