var initData = {
  list: [], //列表数据
  count: 0, //列表总数
  curr: 1, //当前页
  limit: 500 //每页数量
}
var snapshot_data = [];
var snapshot_rm = [];
var send_data = [];
var rm_i = 0;

function encodeHtml(str) {
  var encodedStr = "";
  if (str == "") return encodedStr;
  else {
    for (var i = 0; i < str.length; i++) {
      encodedStr += "&#" + str.substring(i, i + 1).charCodeAt().toString(10) + ";";
    }
  }
  return encodedStr;
}

function refreshSnapshots(data, count, curr) {

  layui.use('laypage', function() {
    var laypage = layui.laypage;
    laypage.render({
      elem: 'jv-paging',
      count: count, //数据总数，从服务端得到,
      limit: initData.limit,
      curr: curr,
      prev: ' ', //若不显示，设置false即可
      next: ' ', //若不显示，设置false即可
      jump: function(obj, first) {
        //obj包含了当前分页的所有参数，比如：
        // obj.limit 得到每页显示的条数
        initData.curr = obj.curr;
        let t = arrTrans(initData.limit, data);
        jQuery('#jv-pageitemV').text(initData.limit);
        jQuery('#snapshots_list').html('');
        jQuery("#jv-snapshot-selectall").prop("checked", false);
        jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content_disabled').attr('disabled', true);
        if (count <= initData.limit) {
          initData.curr = 1;
        }
        if (data.length) {
          var len = t[initData.curr - 1].length;
          for (var i = 0; i < len; i++) {
            let info = t[initData.curr - 1][i];

            var zfilesys_status = false;

            var tr = '<tr class="infosnapshot">' +
              '<td style="width:5%;text-align:center;">' +
              '<span class="unas_table_text"><div class="unas_checkbox"><input type="checkbox" name="snapshot_check" id="snapshot_check' + i + '" zpool="' + info.zpool + '" zfilesys="' + info.zfilesys + '" snap="' + info.name + '"' +
              '><label for="snapshot_check' + i + '"></label></div></span>' +
              '</td>' +

              '<td width="70%" align="left"><span class="unas_table_text jvc-snapshotname">' + info.name + '</span></td>' +
              '<td width="25%" align="center"><div class="unas-flex" style="justify-content: space-between;">' +
              '<span>' +
              '<a class="'+(info.mounted ? 'unmounticon' : 'mounticon')+'" onClick="' + (info.mounted ? 'submit_umount' : 'submit_mount') + '(this);" zpool="' + info.zpool + '" zfilesys="' + info.zfilesys + '" snap="' + info.name + '" title="' + '##$@zfs@$##' + (info
                .mounted ? 'Unmount' : 'Mount') + '##$@zfs@$##' + '"></a>' +
              '</span>' +
              '<span>' +
              '<a class="cloneicon" onClick="submit_clone(this);" zpool="' + info.zpool + '" zfilesys="' + info.zfilesys + '" snap="' + info.name + '" title="' + '##$@zfs@$##Clone##$@zfs@$##' + '"></a>' +
              '</span>' +
              '<span><a class="rollbackicon" onClick="submit_rollback(this);" zpool="' + info.zpool + '" zfilesys="' + info.zfilesys + '" snap="' + info.name + '" title="' + '##$@zfs@$##Rollback##$@zfs@$##' + '"></a>' +
              '</span>' +
              '<div>' +
              '<span class="jvc-sendingicon"><a class="sendingicon" onClick="submit_send(this);" zpool="' + info.zpool + '" zfilesys="' + info.zfilesys + '" snap="' + info.name + '" title="' + '##$@zfs@$##Send##$@zfs@$##' + '"></a>' +
              '</span><div class="cupUsageEC jvc-cupUsageEC"></div>' +
              '</div>' +
              '<span class="unas_table_text">' + '<a class="deleteicon" onClick="submit_delSnapzfilesys(this);" zpool="' + info.zpool + '" zfilesys="' + info.zfilesys + '" snap="' + info.name +
              '" oldshare="' + (zfilesys_status ? 'yes' : 'no') + '" tag="' + info.tag + '" title="' + '##$@zfs@$##Delete##$@zfs@$##' + '"></a></span></div></td></tr>';
            jQuery('#snapshots_list').append(tr);

          }
          var len_snapshot = jQuery('#snapshots_list tr').length;
          jQuery('#snapshots_list tr').each(function(i, e) {
            seteChart(jQuery(e).find('.jvc-cupUsageEC')[0], 0, '#08cea1');
          })

          jQuery('#snapshots_list tr').each(function(i, e) {
            jQuery(e).find('input[name="snapshot_check"]').on('click', function() {
              if (jQuery('input[name="snapshot_check"]:checked').length <= 0) {
                jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content_disabled').attr('disabled', true);
              } else {
                jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content').attr('disabled', false);
                if (jQuery('input[name="snapshot_check"]:checked').length == len_snapshot) {
                  jQuery("#jv-snapshot-selectall").prop("checked", true);
                } else {
                  jQuery("#jv-snapshot-selectall").prop("checked", false);
                }
              }
            })
          })


          jQuery("#snapshots_list tr:even").addClass("tr_even");
          jQuery("#snapshots_list tr:odd").addClass("tr_odd");
          jQuery('#snapshots_list tr').mouseover(function() {
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery(this).toggleClass("tr_hover");
          });
          jQuery('#snapshots_list tr').mouseout(function() {
            jQuery(this).toggleClass("tr_hover");
            jQuery(this).removeClass("tr_even tr_odd");
            jQuery("#snapshots_list tr:even").addClass("tr_even");
            jQuery('#snapshots_list tr:odd').addClass("tr_odd");
          });

        }

        jQuery('#jv-pageitemList').children().each(function(i, e) {
          e.onclick = function() {
            initData.limit = jQuery(e).text();
            refreshSnapshots(data, count, initData.curr);
          }
        })
        if (obj.pages >= 1 && obj.count) {
          jQuery('#jv-footerPage').show();
        } else {
          jQuery('#jv-footerPage').hide();
        }

        //首次不执行
        if (!first) {
          refreshSnapshots(data, count, initData.curr);
        }

        zfsTranslator('snapshots_list');
      }
    });
  });
  getSendProgress();
}

function getSendProgress() {
  clearTimeout(send_tiem);
  let data = {
    cmd: 'zfs_snapshot_info',
    params: {
      "zpool": jQuery('#snapshot_zpoolname').text(),
      "zfilesys": jQuery('#snapshot_zfilesysname').text()
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 3000000,
    success: function(result) {
      var info = result.results;
      var running = info.running || {};
      send_data = running.send || [];

      if (send_data.length) {
        jQuery('#snapshots_list tr').each(function(i, e) {
          for (var k = 0; k < send_data.length; k++) {
            var send_info = send_data[k];
            var n = jQuery(e).find('.jvc-snapshotname').text();
            if (send_info.snapshot == jQuery(e).find('.jvc-snapshotname').text()) {
              var p = send_info.progress.percent * 100 || 0;
              if (p > 100) {
                p = 99;
              }
              jQuery(e).find('.jvc-cupUsageEC').show();
              jQuery(e).find('.jvc-sendingicon').hide();
              seteChart(jQuery(e).find('.jvc-cupUsageEC')[0], parseInt(p), '#08cea1');
              break;
            } else {
              jQuery(e).find('.jvc-cupUsageEC').hide();
              jQuery(e).find('.jvc-sendingicon').show();
            }
          }
        })
      } else {
        jQuery('.jvc-cupUsageEC').hide();
        jQuery('.jvc-sendingicon').show();
      }

      if (send_data.length) {
        send_tiem = setTimeout(function() {
          getSendProgress();
        }, 2000);
      } else {
        clearTimeout(send_tiem);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {}
  });
}


function getSnapshotsInfo(f) {
  jQuery('#zfs_manager_snapshot_waiting_content').attr("style", "display:block");
  jQuery('#zfs_manager_snapshot_waiting_logo').attr("style", "display:block");
  let data = {
    cmd: 'zfs_snapshot_info',
    params: {
      "zpool": jQuery('#snapshot_zpoolname').text(),
      "zfilesys": jQuery('#snapshot_zfilesysname').text()
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 3000000,
    success: function(result) {
      var dd = result.results;
      var data = result.results.data;
      var running = dd.running || {};
      send_data = running.send || [];
      snapshot_data = result.results.data || [];

      refreshSnapshots(snapshot_data, data.length, initData.curr);
      checkSnapZfilesysname();
      //replication tasks
      // var replications = dd.replicationTasks;
      // jQuery('#replications_list').html('');
      // if (replications != false) {
      //   for (var key in replications) {
      //     var v = replications[key];
      //     var tr = '<tr><td width="20%" align="left"><span class="unas_table_text" style="margin-left:20px;">' + key + '</span></td>' +
      //       '<td width="20%" align="center"><span class="unas_table_text">' +
      //       v.dataset +
      //       '</span></td>' +
      //       '<td width="20%" align="center"><span class="unas_table_text">' +
      //       v.SendToDir +
      //       '</span></td>' +
      //       '<td width="20%" align="center"><span class="unas_table_text">' +
      //       v.Timing +
      //       '</span></td>' +
      //       '<td width="20%" align="center"><span class="unas_table_text">' +
      //       '<span><a class="deleteicon" onClick="replication_delete(this);" name="' + key + '" "' + '" title="' + '##$@zfs@$##Delete##$@zfs@$##' + '"></a>' +
      //       '</span></td></tr>'
      //     jQuery('#replications_list').append(tr);
      //
      //   }
      //   jQuery("#replications_list tr:even").addClass("tr_even");
      //   jQuery("#replications_list tr:odd").addClass("tr_odd");
      //   jQuery('#replications_list tr').mouseover(function() {
      //     jQuery(this).removeClass("tr_even tr_odd");
      //     jQuery(this).toggleClass("tr_hover");
      //   });
      //   jQuery('#replications_list tr').mouseout(function() {
      //     jQuery(this).toggleClass("tr_hover");
      //     jQuery(this).removeClass("tr_even tr_odd");
      //     jQuery("#replications_list tr:even").addClass("tr_even");
      //     jQuery('#replications_list tr:odd').addClass("tr_odd");
      //   });
      //   zfsTranslator('replications_list');
      // }
      //zfs-auto-snapshot
      var autosnap = dd.autosnap;
      if (autosnap.status) {
        jQuery('#create_zfssnaptask_schedule').prop('checked', true);
        jQuery('#zfs_snap_frequent').prop('disabled', false);
        jQuery('#zfs_snap_hourly').prop('disabled', false);
        jQuery('#zfs_snap_daily').prop('disabled', false);
        jQuery('#zfs_snap_weekly').prop('disabled', false);
        jQuery('#zfs_snap_monthly').prop('disabled', false);
        jQuery('#snap_set_copies').prop('disabled', false);
        jQuery('#snap_set_keep_text').prop('disabled', false);

      } else {
        jQuery('#create_zfssnaptask_schedule').prop('checked', false);
        jQuery('#zfs_snap_frequent').prop('disabled', true);
        jQuery('#zfs_snap_hourly').prop('disabled', true);
        jQuery('#zfs_snap_daily').prop('disabled', true);
        jQuery('#zfs_snap_weekly').prop('disabled', true);
        jQuery('#zfs_snap_monthly').prop('disabled', true);
        jQuery('#snap_set_copies').prop('disabled', true);
        jQuery('#snap_set_keep_text').prop('disabled', true);
      }
      if (autosnap.Minutely) {
        jQuery('#zfs_snap_frequent').prop('checked', true);
        jQuery('#zfs_snap_frequent_copies').prop('disabled', false);
      } else {
        jQuery('#zfs_snap_frequent').prop('checked', false);
        jQuery('#zfs_snap_frequent_copies').prop('disabled', true);
      }
      if (autosnap.Hourly) {
        jQuery('#zfs_snap_hourly').prop('checked', true);
        jQuery('#zfs_snap_hourly_copies').prop('disabled', false);
      } else {
        jQuery('#zfs_snap_hourly').prop('checked', false);
        jQuery('#zfs_snap_hourly_copies').prop('disabled', true);
      }
      if (autosnap.Daily) {
        jQuery('#zfs_snap_daily').prop('checked', true);
        jQuery('#zfs_snap_daily_copies').prop('disabled', false);
      } else {
        jQuery('#zfs_snap_daily').prop('checked', false);
        jQuery('#zfs_snap_daily_copies').prop('disabled', true);
      }
      if (autosnap.Weekly) {
        jQuery('#zfs_snap_weekly').prop('checked', true);
        jQuery('#zfs_snap_weekly_copies').prop('disabled', false);
      } else {
        jQuery('#zfs_snap_weekly').prop('checked', false);
        jQuery('#zfs_snap_weekly_copies').prop('disabled', true);
      }
      if (autosnap.Monthly) {
        jQuery('#zfs_snap_monthly').prop('checked', true);
        jQuery('#zfs_snap_monthly_copies').prop('disabled', false);
      } else {
        jQuery('#zfs_snap_monthly').prop('checked', false);
        jQuery('#zfs_snap_monthly_copies').prop('disabled', true);
      }

      if (autosnap.status) {
        jQuery('#zfs_snap_frequent_copies').val(autosnap.MinutelyCopies);
        jQuery('#zfs_snap_hourly_copies').val(autosnap.HourlyCopies);
        jQuery('#zfs_snap_daily_copies').val(autosnap.DailyCopies);
        jQuery('#zfs_snap_weekly_copies').val(autosnap.WeeklyCopies);
        jQuery('#zfs_snap_monthly_copies').val(autosnap.MonthlyCopies);
      } else {
        jQuery('#zfs_snap_frequent_copies').val('15');
        jQuery('#zfs_snap_hourly_copies').val('24');
        jQuery('#zfs_snap_daily_copies').val('7');
        jQuery('#zfs_snap_weekly_copies').val('4');
        jQuery('#zfs_snap_monthly_copies').val('12');
      }

      setTimeout(function() {
        jQuery('#zfs_manager_snapshot_waiting_content').attr("style", "display:none");
        jQuery('#zfs_manager_snapshot_waiting_logo').attr("style", "display:none");
      }, 100);

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
      jQuery('#zfs_manager_snapshot_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_snapshot_waiting_logo').attr("style", "display:none");
    }
  });
}

function checkSnapZfilesysname() {
  var state = 1;
  var zfilesysname = "";
  var zfilesysname = jQuery.trim(jQuery('#newsnapshot_name').val()).toLowerCase();
  var zpoolname = "";
  var zpoolname = jQuery.trim(jQuery('#snapshot_zpoolname').html());

  for (var i = 0; i < snapshot_data.length; i++) {
    if (snapshot_data[i].name == zfilesysname) {
      state = 0;
    }
  }

  if (state) {
    jQuery('#newsnapshot_name').attr('class', 'unas_input');
    jQuery("#newsnapshot_name").attr('title', '');

  } else {
    jQuery('#newsnapshot_name').attr('class', 'unas_input_error');
    jQuery("#newsnapshot_name").attr('title', UNAS._('##$@zfs@$##Volume name is already in use##$@zfs@$##'));
  }

}

function submit_addSnapshot() {
  var snap = jQuery.trim(jQuery('#newsnapshot_name').val()).toLowerCase();
  if (jQuery.trim(snap) == "") {
    return false;
  }
  var zfilesysname = "";
  var zfilesysname = jQuery('#snapshot_zfilesysname').html();
  var zpoolname = "";
  var zpoolname = jQuery('#snapshot_zpoolname').html();
  if (jQuery("#newsnapshot_name").attr("class") != "unas_input_error") {

    let data = {
      cmd: 'zfs_snapshot_new',
      params: {
        "zpool": zpoolname,
        "zfilesys": zfilesysname,
        "name": snap
      }
    }
    jQuery('#zfs_manager_snapshot_waiting_content').attr("style", "display:block");
    jQuery('#zfs_manager_snapshot_waiting_logo').attr("style", "display:block");
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 3000000,
      success: function(data) {
        if (data) {
          getSnapshotsInfo();
          var w = window.top.UNAS.GetWindow('SnapshotWindow');
          w.ProcessSnapshot();
          jQuery('#newsnapshot_name').val('');
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  }
}

function replication_delete(e) {
  var name = jQuery(e).attr('name');
  var data = {
    cmd: 'zfs_snapshot_replicate_rm',
    params: {
      name: name
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    timeout: 30000,
    data: JSON.encode(data),
    success: function(data) {
      if (data == "2") {
        jQuery("#mountzfilesys_checkkey").attr('style', 'display:');
        jQuery("#mountzfilesys_checkkey").attr('title', UNAS._('##$@zfs@$##The password is invalid.##$@zfs@$##'));
      }
      getSnapshotsInfo();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });

}

function submit_editSnapzfilesys(e) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery(e).attr('zpool');
  var zfilesys = jQuery(e).attr('zfilesys');
  var oldshare = jQuery(e).attr('oldshare');
  var share = jQuery('#snapshare' + zpool + '-' + snap_name).val();
  var tag = jQuery(e).attr('tag');
  var crypt = jQuery('#snapshot_zfilesyscrypt').val();
  if (share != oldshare) {
    jQuery.ajax({
      url: "/apps/zfs/include/zfs_fun.php",
      type: "POST",
      async: true,
      data: {
        snap_name: snap_name,
        zpool: zpool,
        zfilesys: zfilesys,
        share: share,
        oldshare: oldshare,
        tag: tag,
        crypt: crypt,
        action: "editsnapshot"
      },
      timeout: 30000,
      success: function(data) {
        if (data == "2") {
          jQuery("#mountzfilesys_checkkey").attr('style', 'display:');
          jQuery("#mountzfilesys_checkkey").attr('title', UNAS._('##$@zfs@$##The password is invalid.##$@zfs@$##'));
        }
        getSnapshotsInfo();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  }
}

function submit_delSnapzfilesys(e) {
  unasConfirm({
    msg: "Are you sure to delete the snapshot?"
  }, function() {
    zfs_snapshot_rm(e);
  })
}

function zfs_snapshot_rm(e, f) {
  var snapshots = [];
  var zpool = jQuery('#snapshot_zpoolname').text();
  var zfilesys = jQuery('#snapshot_zfilesysname').text();

  var crypt = jQuery('#snapshot_zfilesyscrypt').val();
  if (jQuery.isArray(e)) {
    for (var i = 0; i < e.length; i++) {
      var name = jQuery(e[i]).attr('snap');
      snapshots.push([zpool, zfilesys, name]);
    }
  } else {
    var name = jQuery(e).attr('snap');
    snapshots = [
      [zpool, zfilesys, name]
    ];
  }

  let data = {
    cmd: 'zfs_snapshot_rm',
    params: {
      snapshots: snapshots
    }
  }
  jQuery('#zfs_manager_snapshot_waiting_content').attr("style", "display:block");
  jQuery('#zfs_manager_snapshot_waiting_logo').attr("style", "display:block");

  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 300000,
    success: function(data) {
      getSnapshotsInfo();
      var w = window.top.UNAS.GetWindow('SnapshotWindow');
      w.ProcessSnapshot();
    },
    complete: function() {

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function snapshot_deleteS() {

  unasConfirm({
    msg: "Are you sure to delete the snapshot?"
  }, function() {
    snapshot_rm = [];
    jQuery('#snapshots_list tr').each(function(i, e) {
      if (jQuery(e).find('input[type="checkbox"]').prop("checked")) {
        var that = jQuery(e).find('input[type="checkbox"]');
        snapshot_rm.push(that);
      }
    })
    zfs_snapshot_rm(snapshot_rm, 1);
  })

}


function submit_rollback(e) {

  unasConfirm({
    msg: "Are you sure to rollback the snapshot? Current data will be lost!"
  }, function() {
    var snap_name = jQuery(e).attr('snap');
    var zpool = jQuery('#snapshot_zpoolname').html();
    var zfilesys = jQuery('#snapshot_zfilesysname').html();
    var share = jQuery(e).attr('oldshare');
    var tag = jQuery(e).attr('tag');
    var crypt = jQuery('#snapshot_zfilesyscrypt').val();
    let data = {
      cmd: 'zfs_snapshot_rollback',
      params: {
        name: snap_name,
        zpool: zpool,
        zfilesys: zfilesys
      }
    }
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 30000,
      success: function(data) {
        getSnapshotsInfo();
        var w = window.top.UNAS.GetWindow('SnapshotWindow');
        w.ProcessSnapshot();
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })

}

function submit_mount(e, f) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery('#snapshot_zpoolname').html();
  var zfilesys = jQuery('#snapshot_zfilesysname').html();
  var share = jQuery(e).attr('oldshare');
  var tag = jQuery(e).attr('tag');
  var crypt = jQuery('#snapshot_zfilesyscrypt').val();
  let data = {
    cmd: 'zfs_snapshot_mount',
    params: {
      name: snap_name,
      zpool: zpool,
      zfilesys: zfilesys
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(data) {
      if (f == undefined && !f) {
        getSnapshotsInfo();
        var w = window.top.UNAS.GetWindow('SnapshotWindow');
        w.ProcessSnapshot();
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function snapshot_mountS() {
  var k = 0;
  jQuery('#snapshots_list tr').each(function(i, e) {
    if (jQuery(e).find('input[type="checkbox"]').prop("checked")) {
      var that = jQuery(e).find('input[type="checkbox"]');
      submit_mount(that, 1);
      k++;
    }
  })
  if (k == jQuery('#snapshots_list input[type="checkbox"]:checked').length) {
    getSnapshotsInfo();
  }
}

function submit_umount(e) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery('#snapshot_zpoolname').html();
  var zfilesys = jQuery('#snapshot_zfilesysname').html();
  var share = jQuery(e).attr('oldshare');
  var tag = jQuery(e).attr('tag');
  var crypt = jQuery('#snapshot_zfilesyscrypt').val();
  let data = {
    cmd: 'zfs_snapshot_umount',
    params: {
      name: snap_name,
      zpool: zpool,
      zfilesys: zfilesys
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(data) {
      getSnapshotsInfo();
      var w = window.top.UNAS.GetWindow('SnapshotWindow');
      w.ProcessSnapshot();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function submit_clone(e) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery('#snapshot_zpoolname').html();
  var zfilesys = jQuery('#snapshot_zfilesysname').html();
  var share = jQuery(e).attr('oldshare');
  var tag = jQuery(e).attr('tag');
  var crypt = jQuery('#snapshot_zfilesyscrypt').val();
  let data = {
    cmd: 'zfs_snapshot_clone',
    params: {
      name: snap_name,
      zpool: zpool,
      zfilesys: zfilesys
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: 'application/json',
    data: JSON.encode(data),
    timeout: 30000,
    success: function(data) {
      getSnapshotsInfo();
      var w = window.top.UNAS.GetWindow('SnapshotWindow');
      w.ProcessSnapshot();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });
}

function submit_send(e) {
  var snap_name = jQuery(e).attr('snap');
  var zpool = jQuery(e).attr('zpool');
  var zfilesys = jQuery(e).attr('zfilesys');
  var sendSnapshotWindow = new MUI.Modal({
    id: 'jv-sendSnapshotWindow',
    title: window.top.UNAS._('##$@zfs@$##Send Snapshot##$@zfs@$##'),
    modal: true,
    width: 550,
    height: 380,
    data: {
      snap_name: snap_name,
      zpool: zpool,
      zfilesys: zfilesys
    },
    modalOverlayClose: false,
    contentURL: '/apps/zfs/send_snapshot.html?v=0.0.1',
  });
  sendSnapshotWindow.callBack = function() {
    getSnapshotsInfo();
  }
}

function snapshot_sendS(e) {
  var sendSnapshotWindow = new MUI.Modal({
    id: 'jv-sendSnapshotWindow',
    title: window.top.UNAS._('##$@zfs@$##Send Snapshot##$@zfs@$##'),
    modal: true,
    width: 550,
    height: 380,
    data: {
      type: 'list'
    },
    modalOverlayClose: false,
    contentURL: '/apps/zfs/send_snapshot.html?v=0.0.1',
  });
}


function AutoSnapClick(id) {
  if (jQuery("#" + id).is(':checked')) {
    jQuery("#" + id + "_copies").prop('disabled', false); //show
  } else {
    jQuery("#" + id + "_copies").prop('disabled', true); //hide
  }
  jQuery("#zfs_autosnap_submit").attr("class", "unas_button_sub");
}

function submit_receiveSnapshot() { //receive snapshot
  alert("receive snapshot");

}

function submit_AutoSnap() {
  jQuery('#zfs_manager_snapshot_waiting_content').attr("style", "display:block");
  jQuery('#zfs_manager_snapshot_waiting_logo').attr("style", "display:block");

  var autosnap = jQuery("#create_zfssnaptask_schedule").prop('checked');
  var frequent = jQuery("#zfs_snap_frequent").prop('checked');
  var hourly = jQuery("#zfs_snap_hourly").prop('checked');
  var daily = jQuery("#zfs_snap_daily").prop('checked');
  var weekly = jQuery("#zfs_snap_weekly").prop('checked');
  var monthly = jQuery("#zfs_snap_monthly").prop('checked');

  var frequent_copies = parseInt(jQuery("#zfs_snap_frequent_copies").val());
  var hourly_copies = parseInt(jQuery("#zfs_snap_hourly_copies").val());
  var daily_copies = parseInt(jQuery("#zfs_snap_daily_copies").val());
  var weekly_copies = parseInt(jQuery("#zfs_snap_weekly_copies").val());
  var monthly_copies = parseInt(jQuery("#zfs_snap_monthly_copies").val());
  var zpool = jQuery('#snapshot_zpoolname').html();
  var zfilesys = jQuery('#snapshot_zfilesysname').html();

  let data = {
    cmd: 'zfs_snapshot_set',
    params: {
      "zfs": [
        [zpool, zfilesys]
      ],
      "autosnap": autosnap,
      "frequent": frequent,
      "hourly": hourly,
      "daily": daily,
      "weekly": weekly,
      "monthly": monthly,
      "frequent_copies": frequent_copies,
      "hourly_copies": hourly_copies,
      "daily_copies": daily_copies,
      "weekly_copies": weekly_copies,
      "monthly_copies": monthly_copies
    }

  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 300000,
    success: function(data) {
      jQuery('#zfs_manager_snapshot_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_snapshot_waiting_logo').attr("style", "display:none");
      getSnapshotsInfo();
      var w = window.top.UNAS.GetWindow('SnapshotWindow');
      w.ProcessSnapshot();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      jQuery('#zfs_manager_snapshot_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_snapshot_waiting_logo').attr("style", "display:none");

      alert(textStatus);
    }
  });

}

function addTimeZero_zfssnapshot(num) {
  return num >= 10 ? num : '0' + num;
}

function createTaskWin(info = '', type = '') {
  var title = UNAS._('##$@zfs@$##Create send task##$@zfs@$##');
  type && (title = UNAS._('##$@zfs@$##Edit Task##$@zfs@$##'));
  var createsendtaskWin = new MUI.Modal({
    id: 'jv-createsendtaskWindow',
    title: title,
    modal: true,
    modalOverlayClose: false,
    width: 800,
    height: 550,
    sendtask: {
      info: info,
      type: type
    },
    onClose:function(){
      send_reqstatus = 0;
    },
    contentURL: '/apps/zfs/zfs_sendtask.html?v=0.0.1&'
  });
}

// function createTaskWin() {
//   var createTaskWindow = new MUI.Modal({
//     id: 'jv-createTaskWindow',
//     title: window.top.UNAS._('##$@zfs@$##Create Task##$@zfs@$##'),
//     modal: true,
//     width: 800,
//     height: 360,
//     data: {},
//     modalOverlayClose: false,
//     contentURL: '/apps/zfs/create_task.html?v=0.0.1',
//   });
//   createTaskWindow.callBack = function() {
//     getSnapshotsInfo();
//   }
// }

(function() {

  var today = new Date();
  var date = today.getFullYear() + ('0' + (today.getMonth() + 1)).slice(-2) + ('0' + today.getDate()).slice(-2);
  var time = ('0' + today.getHours()).slice(-2) + ('0' + today.getMinutes()).slice(-2) + ('0' + today.getSeconds()).slice(-2);
  var dateTime = date + '_' + time;

  jQuery('#newsnapshot_name').val(dateTime);

  jQuery("#jv-replications-table-content, #jv-snapshots_list_table_content").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  getSnapshotsInfo();
  jQuery('div[zfsitemtabid]').click(function() {
    var id = jQuery(this).attr('zfsitemtabid');
    jQuery('#zfs_manager_general_tab').attr('class', 'unas_tab');
    jQuery('#zfs_manager_autosnap_tab').attr('class', 'unas_tab');
    jQuery('#zfs_manager_expand_tab').attr('class', 'unas_tab');
    jQuery('#zfs_manager_advanced_tab').attr('class', 'unas_tab');
    jQuery(this).attr('class', 'unas_tab_sel');

    jQuery('#zfs_manager_zfs_container').attr('style', 'display:none');
    jQuery('#zfs_snapshot_advanced_container').attr('style', 'display:none');
    jQuery('#zfs_snapshot_general_container').attr('style', 'display:none');
    jQuery('#zfs_snapshot_snap_container').attr('style', 'display:none');
    jQuery('#zfs_snapshot_replication_container').attr('style', 'display:none');
    jQuery('#' + id).attr('style', 'display:block');
    if (id == "zfs_snapshot_replication_container") {
      // getExtendPVsInfo();
      zfssnapshot_updatetaskrate();
    }
  });
  jQuery('#create_zfssnaptask_schedule').click(function() {
    if (jQuery('#create_zfssnaptask_schedule').prop('checked') == true) {
      jQuery('#zfs_snap_frequent').prop('disabled', false);
      jQuery('#zfs_snap_hourly').prop('disabled', false);
      jQuery('#zfs_snap_daily').prop('disabled', false);
      jQuery('#zfs_snap_weekly').prop('disabled', false);
      jQuery('#zfs_snap_monthly').prop('disabled', false);
      jQuery('#snap_set_copies').prop('disabled', false);
      jQuery('#snap_set_keep_text').prop('disabled', false);

      jQuery('#zfs_snap_frequent_copies').prop('disabled', false);
      jQuery('#zfs_snap_hourly_copies').prop('disabled', false);
      jQuery('#zfs_snap_daily_copies').prop('disabled', false);
      jQuery('#zfs_snap_weekly_copies').prop('disabled', false);
      jQuery('#zfs_snap_monthly_copies').prop('disabled', false);
      jQuery('#snap_set_copies_copies').prop('disabled', false);

    } else {
      jQuery('#zfs_snap_frequent').prop('disabled', true);
      jQuery('#zfs_snap_hourly').prop('disabled', true);
      jQuery('#zfs_snap_weekly').prop('disabled', true);
      jQuery('#zfs_snap_daily').prop('disabled', true);
      jQuery('#zfs_snap_monthly').prop('disabled', true);
      jQuery('#snap_set_copies').prop('disabled', true);
      jQuery('#snap_set_keep_text').prop('disabled', true);


      jQuery('#zfs_snap_frequent_copies').prop('disabled', true);
      jQuery('#zfs_snap_hourly_copies').prop('disabled', true);
      jQuery('#zfs_snap_weekly_copies').prop('disabled', true);
      jQuery('#zfs_snap_daily_copies').prop('disabled', true);
      jQuery('#zfs_snap_monthly_copies').prop('disabled', true);
      jQuery('#snap_set_copies_copies').prop('disabled', true);
    }
    jQuery("#zfs_autosnap_submit").attr("class", "unas_button_sub");
  });

  jQuery("#jv-snapshot-selectall").click(function() {
    if (!jQuery('#snapshots_list tr').length) {
      return;
    }
    if (jQuery("#jv-snapshot-selectall").prop("checked")) {
      jQuery("input[name='snapshot_check']").prop("checked", true);
      jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content').attr('disabled', false);
    } else {
      jQuery("input[name='snapshot_check']").prop("checked", false);
      jQuery('#jv-snapshotopbtn button').attr('class', 'unas_button_content_disabled').attr('disabled', true);
    }
  });

})();
