function autosnap_zfstorage() {

  jQuery.ajax({
    url: '/wmi/',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'bdrclientisp_zfstorage'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      var i = 0
      jQuery('#jv-poolhost-autosnap').empty();
      for (var v in info) {
        if (info.hasOwnProperty(v)) {
          var tp_ = info[v];
          var pooldom = zfsTemplateAppend('#jv-poolhost-autosnap', 'jvt-pooldatasetitem-autosnap', 'jvt-pooldatasetitem-autosnap-' + i);
          pooldom.find('.poolname').text(v || '--');
          if (i == 0) {
            pooldom.find('.pool-c').removeClass('pool-o');
            pooldom.find('.datasetlist').show();
          } else {
            pooldom.find('.pool-c').addClass('pool-o');
            pooldom.find('.datasetlist').hide();
          }

          pooldom.find('input[name=pool]').on('click', function() {
            var len = jQuery('#jv-poolhost-autosnap input[name=pool]').length;
            var len_ck = jQuery('#jv-poolhost-autosnap input[name=pool]:checked').length;
            if (len == len_ck) {
              jQuery('#jv-pdallchk').prop('checked', true);
            } else {
              jQuery('#jv-pdallchk').prop('checked', false);
            }
            //jQuery('#jv-poolhost-autosnap input[name=pool]').not(this).prop('checked', false);
            var pnode_siblings = jQuery('#jv-poolhost-autosnap input[name=pool]').not(this);

            var pnode = jQuery(this).closest('div.pool-datase-titem');
            if (jQuery(this).prop('checked')) {
              pnode.find('.datasetlist input').prop('checked', true);
            } else {
              pnode.find('.datasetlist input').prop('checked', false);
            }

            // pnode_siblings.each(function(k, e) {
            //   var epnode = jQuery(e).closest('div.pool-datase-titem');
            //   epnode.find('.datasetlist input').prop('checked', false);
            // })

          })

          var j = 0;
          for (var k in tp_) {
            if (tp_.hasOwnProperty(k)) {
              var td_ = tp_[k];
              var ddom = zfsTemplateAppend(pooldom.find('.datasetlist'), 'jvt-datasetitem-autosnap', 'jvt-datasetitem-autosnap-' + i + j)
              ddom.attr('style', "justify-content: space-between");
              ddom.find('.datasetname').text(k || '--');

              ddom.find('input[name=dataset]').val(td_.lv).attr('vg', td_.vg).on('click', function() {
                var pnode = jQuery(this).closest('div.pool-datase-titem');

                autosnap_uppoolchecked(pnode);

                // var pnode_siblings = jQuery('#jv-poolhost-autosnap .pool-datase-titem').not(pnode);
                //
                // pnode_siblings.each(function(k, e) {
                //   jQuery(e).find('input').prop('checked', false);
                // })

              })
            }
            j++;
          }
        }
        i++;
      }

      jQuery('#jv-poolhost-autosnap').children().each(function(i, e) {
        autosnap_uppoolchecked(jQuery(e));
      });

      if (jQuery('#jv-poolhost-autosnap').children().length) {
        jQuery('#jv-pdtop').show();
      }

      jQuery('#jv-poolhost-autosnap input[type=checkbox]').on('click', function() {
        if (jQuery('#jv-poolhost-autosnap input[type=checkbox]:checked').length) {
          jQuery('#jv-determineautosnapshotbtn').attr('class', 'unas_button_sub');
        } else {
          jQuery('#jv-determineautosnapshotbtn').attr('class', 'unas_button_sub_disabled');
        }
      })

      jQuery('#jv-poolhost-autosnap input[type=radio]').on('click', function() {
        if (jQuery('#jv-poolhost-autosnap input[type=radio]:checked').length) {
          jQuery('#jv-determineautosnapshotbtn').attr('class', 'unas_button_sub');
        } else {
          jQuery('#jv-determineautosnapshotbtn').attr('class', 'unas_button_sub_disabled');
        }
      })

    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function autosnap_uppoolchecked(pnode) {

  var d_len = pnode.find('input[name=dataset]').length;
  var d_len_ck = pnode.find('input[name=dataset]:checked').length;
  if (d_len == d_len_ck) {
    pnode.find('input[name=pool]').prop('checked', true);
  } else {
    pnode.find('input[name=pool]').prop('checked', false);
  }
  var p_len = jQuery('#jv-poolhost-autosnap input[name=pool]').length;
  var p_len_ck = jQuery('#jv-poolhost-autosnap input[name=pool]:checked').length;

  if (p_len == p_len_ck) {
    jQuery('#jv-pdallchk').prop('checked', true);
  } else {
    jQuery('#jv-pdallchk').prop('checked', false);
  }

}

function submit_setAutoSnap() {
  var zfs = [];
  jQuery('#jv-poolhost-autosnap input[name=dataset]:checked').each(function(i, e){
    var zf = jQuery(e).val();
    var zp = jQuery(e).attr('vg');
    zfs.push([zp, zf]);
  })
  var autosnap = true;
  var frequent = jQuery("#jv_autosnap_frequent").prop('checked');
  var hourly = jQuery("#jv_autosnap_hourly").prop('checked');
  var daily = jQuery("#jv_autosnap_daily").prop('checked');
  var weekly = jQuery("#jv_autosnap_weekly").prop('checked');
  var monthly = jQuery("#jv_autosnap_monthly").prop('checked');

  var frequent_copies = parseInt(jQuery("#jv_autosnap_frequent_copies").val());
  var hourly_copies = parseInt(jQuery("#jv_autosnap_hourly_copies").val());
  var daily_copies = parseInt(jQuery("#jv_autosnap_daily_copies").val());
  var weekly_copies = parseInt(jQuery("#jv_autosnap_weekly_copies").val());
  var monthly_copies = parseInt(jQuery("#jv_autosnap_monthly_copies").val());

  let data = {
    cmd: 'zfs_snapshot_set',
    params: {
      "zfs" : zfs,
      "autosnap": autosnap,
      "frequent": frequent,
      "hourly": hourly,
      "daily": daily,
      "weekly": weekly,
      "monthly": monthly,
      "frequent_copies": frequent_copies,
      "hourly_copies": hourly_copies,
      "daily_copies": daily_copies,
      "weekly_copies": weekly_copies,
      "monthly_copies": monthly_copies
    }

  }

  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 300000,
    success: function(res) {
      MUI.closeWindow($('jv-autosnapshotWindow'));
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  });

}

function setbdrstep(i) {
  jQuery('.jvc-bdr-step').hide();
  jQuery('#jv-bdr-step-' + i).fadeIn();
}

jQuery(document).ready(function() {
  autosnap_zfstorage();

  jQuery('#jv-autosnapshotrule input[type=checkbox]').click(function() {
    var pnode = jQuery(this).closest('li.unas_item_li_sub');
    if (this.checked) {
      pnode.find('input[type=number]').attr('disabled', false);

    } else {
      pnode.find('input[type=number]').attr('disabled', true);
    }

    if (jQuery('#jv-autosnapshotrule input[type=checkbox]:checked').length) {
      jQuery('#jv-atuosnap-nextbtn1').attr('class', 'unas_button_sub');
    } else {
      jQuery('#jv-atuosnap-nextbtn1').attr('class', 'unas_button_sub_disabled');
    }
  })

  jQuery("#jv-datasetlistcontent-autosnap").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

})
