var taskWin = window.top.UNAS.GetWindow('jv-createrecvtaskWindow');
var widData = taskWin.options;
var sendtaskdata = widData.recvtask.info;

var recvpooldata = {};

function recvtask_zfstorage() {
  var action = jQuery('input[name=sendto]:checked').val() == 'localfolder' ? 4 : 2;
  if (action == 4) {
    return;
  }
  var host = jQuery('#jv-sshserver-host').val();
  var port = jQuery('#jv-sshserver-port').val();
  var username = jQuery('#jv-sshserver-username').val();
  var password = jQuery('#jv-sshserver-password').val();

  jQuery.ajax({
    url: '/wmi/',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'zfsrep_snapshot_remote',
      "params": {
        host: host,
        port: +port,
        username: username,
        password: password
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      jQuery('#jv-selrecvpoolhost').empty();
      jQuery('#jv-selrecvsnapshost').empty();
      if (res.err == 0) {
        var info = res.results || {};
        recvpooldata = info;
        var i = 0
        for (var v in info) {
          if (info.hasOwnProperty(v)) {
            var tp_ = info[v];
            var pooldom = zfsTemplateAppend('#jv-selrecvpoolhost', 'jvt-zfsrecvpooldatasetitem', 'jvt-zfsrecvpooldatasetitem-' + i);
            pooldom.find('.poolname').text(v || '--');

            if (widData.recvtask.type == 'edit') {
              if (sendtaskdata.path.includes(v)) {
                pooldom.find('.pool-c').removeClass('pool-o');
                pooldom.find('.datasetlist').show();
              } else {
                pooldom.find('.pool-c').addClass('pool-o');
                pooldom.find('.datasetlist').hide();
              }
            } else {
              if (i == 0) {
                pooldom.find('.pool-c').removeClass('pool-o');
                pooldom.find('.datasetlist').show();
              } else {
                pooldom.find('.pool-c').addClass('pool-o');
                pooldom.find('.datasetlist').hide();
              }
            }

            var j = 0;
            for (var k in tp_) {
              if (tp_.hasOwnProperty(k)) {
                var td_ = tp_[k];
                var ddom = zfsTemplateAppend(pooldom.find('.datasetlist'), 'jvt-datasetitem', 'jvt-datasetitem-' + i + j)

                ddom.find('.datasetname').text(k || '--');

                if (widData.recvtask.type == 'edit') {
                  if (sendtaskdata.name == k) {
                    ddom.find('input[name=dataset]').prop('checked', true).attr('pn', v);
                    refreshsnapshotlist((recvpooldata[v][k] || []));
                  }
                }

                ddom.find('input[name=dataset]').val(k).attr('pn', v).on('click', function() {
                  var pnode = jQuery(this).closest('div.pool-datase-titem');
                  var p_i = jQuery(this).attr('pn');
                  if (this.checked) {
                    pnode.find('.datasetitem-recvtask').addClass('nv_hover');
                  }
                  var pnode_siblings = jQuery('#jv-selrecvpoolhost .pool-datase-titem').not(pnode);
                  pnode_siblings.each(function(k, e) {
                    jQuery(e).find('.datasetlist').find('.datasetitem-recvtask').removeClass('nv_hover');
                  })
                  var snapshotlist = recvpooldata[p_i][jQuery(this).val()] || [];
                  refreshsnapshotlist(snapshotlist);
                  jQuery('#jv-sendtask-nextbtn2-2').attr('class', 'unas_button_sub_disabled');
                })
              }
              j++;
            }
          }
          i++;
        }
        if (!jQuery('#jv-selrecvpoolhost').html()) {
          jQuery('#jv-selrecvpoolhost').html('<div class="nullpoolhost unas-flex">' + UNAS._('No pool available')+ '</div>');
        }
      }else {
        errcode[res.err] && (recv_reqstatus && alert(UNAS._('Cannot connect to remote sever') + ': ' + UNAS._(errcode[res.err])));
      }
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      recv_reqstatus && alert(UNAS._('Cannot connect to remote sever') + ': ' + UANS._(textStatus));
    }
  })
}

function recvtask_zfsrep_alload() {

  jQuery.ajax({
    url: '/wmi/',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'zfsrep_alload'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var info = res.results || {};
      var i = 0
      jQuery('#jv-targetpoolhost-recv').empty();
      for (var v in info) {
        if (info.hasOwnProperty(v)) {
          var tp_ = info[v];
          var targetpooldom = zfsTemplateAppend('#jv-targetpoolhost-recv', 'jvt-targetpoolitem-recvtask', 'jvt-targetpoolitem-recvtask-' + i);
          targetpooldom.find('.poolname').text(v || '--');

          if (widData.recvtask.type == 'edit') {
            if (sendtaskdata.pool == v) {
              targetpooldom.find('input[name=targetpool]').prop('checked', true);
            }
          }

          targetpooldom.find('input[name=targetpool]').val(v).on('click', function() {
            jQuery('#jv-recvtask-date').val() && jQuery('#jv-sendtask-nextbtn3').attr('class', 'unas_button_sub');
          });
        }
        i++;
      }

      if (!jQuery('#jv-targetpoolhost-recv').html()) {
        jQuery('#jv-targetpoolhost-recv').html('<div class="nullpoolhost unas-flex">' + UNAS._('No pool available, Please create a pool for replication')+ '</div>');
      }

    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function dislodgeZero(str) {
  let strArray = str.split("/");
  strArray = strArray.map(function(val) {
    if (val[0] == "0") {
      return (val = val.slice(1));
    } else {
      return val;
    }
  });
  return strArray.join("/");
}

function timingtyperecv_on() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.target);
  if (+that.val()) {
    jQuery('#jv-timingitemcon').show();
    if (jQuery('#jv-targetpoolhost-recv input[name=targetpool]:checked').length) {
      jQuery('#jv-sendtask-nextbtn3').attr('class', 'unas_button_sub');
    } else {
      jQuery('#jv-sendtask-nextbtn3').attr('class', 'unas_button_sub_disabled');
    }

  } else {
    jQuery('#jv-timingitemcon').hide();
    jQuery('#jv-sendtask-nextbtn3').attr('class', 'unas_button_sub');
  }
}

function zfsrep_mission_append_recvtask() {
  var timingtype = jQuery('#jv-timingtype').val();
  var caption = jQuery('#jv-taskname').val();
  var action = jQuery('input[name=sendto]:checked').val() == 'localfolder' ? 4 : 2;

  var pool = jQuery('#jv-targetpoolhost-recv input[name=targetpool]:checked').val();
  var path = jQuery('#jv-selrecvsnapshost input[name=snapshotname]:checked').val();
  var host = jQuery('#jv-sshserver-host').val();
  var port = jQuery('#jv-sshserver-port').val();
  var username = jQuery('#jv-sshserver-username').val();
  var password = jQuery('#jv-sshserver-password').val();
  var date = dislodgeZero(jQuery('#jv-recvtask-date').val()).split('/');

  var schedules = [{
    years: [+date[0]],
    months: [+date[1]],
    days: [+date[2]],
    hours: [+jQuery('#recvtask_hours').val()],
    minutes: [+jQuery('#recvtask_minutes').val()]
  }];

  if (timingtype == "0") {
    schedules = [];
  }

  var params = {
    caption: caption, //任务名称
    action: action, //1.send pool, 2.recv pool, 3.send file, 4.recv file
    pool: pool, //本地的 pool
    increment: 1, // 当前不用  1.增量 2.全量
    erase: jQuery('#jv-erase').prop('checked') ? 1 : 0, //当前不用
    encrypt: jQuery('#jv-encrypt').prop('checked') ? 1 : 0, //当前不用
    encryptkey: jQuery('#jv-encryptkey').prop('checked') ? 1 : 0, //当前不用
    schedules: schedules //时间
  }

  if (action == 2) {
    params['path'] = path; //云机上的 pool 名
    params['host'] = host; //云机地址
    params['port'] = port; //云机端口 （ssh）
    params['username'] = username; //云机账号
    params['password'] = password; //云机密码
    params['name'] = jQuery('#jv-selrecvpoolhost input[name=dataset]:checked').val(); //本地的 dataset
  } else {
    var path = jQuery('#jv-localfolderval-recv').val();
    params['path'] = jQuery('#jv-localfolderval-recv').val();
    params['name'] = path.split('@')[0]; //本地的 dataset
  }

  var cmd = 'zfsrep_mission_append';
  if (widData.recvtask.type == 'edit') {
    cmd = 'zfsrep_mission_change';
    params['msnno'] = sendtaskdata.msnno;
  }

  jQuery.ajax({
    url: '/wmi/',
    data: JSON.encode({
      "token": UToken,
      "cmd": cmd,
      "params": params
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      if (res.err == 0) {
        MUI.closeWindow($('jv-createrecvtaskWindow'));
        zfsrep_mission_alload();
      } else {
        alert(res.errmsg);
      }
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function refreshsnapshotlist(data) {
  jQuery('#jv-selrecvsnapshost').empty();
  for (var i = 0; i < data.length; i++) {
    var sdom = zfsTemplateAppend('#jv-selrecvsnapshost', 'jvt-recvsnapsitem', 'jvt-recvsnapsitem-' + i);
    sdom.find('.snapsname').text(data[i] || '--');
    if (widData.recvtask.type == 'edit') {
      if (sendtaskdata.path == data[i]) {
        sdom.find('input[name=snapshotname]').prop('checked', true);
      }
    }
    sdom.find('input[name=snapshotname]').val(data[i]).on('click', function() {
      jQuery('#jv-sendtask-nextbtn2-2').attr('class', 'unas_button_sub');
    })
  }
}

function setrecvtaskstep(i) {
  jQuery('.jvc-set-step').hide();
  jQuery('#jv-set-step-' + i).fadeIn();
  var type = jQuery("input[name='sendto']:checked").val();
  jQuery('#jv-' + type + '-content').show();

  if (jQuery('#jv-sshserver-content').is(':hidden')) {
    recv_reqstatus = 0;
  }else {
    recv_reqstatus = 1;
  }

}

function showdatasetlist_bdrtask() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  var pnode = that.closest('div.pool-datase-titem');
  that.toggleClass('pool-o');
  pnode.find('.datasetlist').slideToggle();
}

function refreshTreeNode_zfsrep_recv(target, node, data) {
  var id = node.id;
  var jsonstr = "[]";
  var jsonarray = eval('(' + jsonstr + ')');
  var ref = jQuery(target).jstree(true);
  jQuery.ajax({
    url: '/apps/zfs/includes/list_dir.php?dir=' + id,
    contentType: 'application/json',
    timeout: 300000,
    dataType: "json",
    success: function(result) {
      var arrays = result || [];
      node.children = [];
      var ch = 0;
      for (var i = 0; i < arrays.length; i++) {
        var icon = '/apps/zfs/js/jstree/images/directory.png';
        if (arrays[i].type != 'dir') {
          icon = '/apps/zfs/js/jstree/images/file.png';
          ch = 0;
        } else {
          ch = 1;
        }

        var checked = false;

        if (arrays[i].name == sendtaskdata.path) {
          checked = true;
        }

        var ck_is = ch ? "no_checkbox" : '';

        var arr = {
          "id": arrays[i].path,
          "text": arrays[i].name,
          "parent": arrays[i].path,
          "type": arrays[i].type,
          'icon': icon,
          'state': {
            "checked": checked
          },
          'a_attr': {
            'class': ck_is
          }
        }

        ref.create_node(node, arr, "last");
      }
      ref.open_node(node);

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);

    }
  });
}

function initTreeData_zfsrep_recv(target, sf, fn) {
  jQuery(target).jstree({
    "core": {
      'data': function(obj, callback) {
        var jsonstr = "[]";
        var jsonarray = eval('(' + jsonstr + ')');
        var url = 'xxxxxxxxxxxx/xxxxxxxxx';
        var arr = {
          "id": '/mnt',
          "text": '/mnt',
          "parent": "#",
          "icon": '/apps/zfs/js/jstree/images/directory.png',
          "type": "dir",
          "state": {
            // "opened": false
            // "selected": false
          },
          'a_attr': {
            'class': "no_checkbox"
          }
        }
        jsonarray.push(arr);


        callback.call(this, jsonarray);

      }.bind(this),
      "themes": {
        "variant": "large", //加大
        "ellipsis": true, //文字多时省略
        dots: true //取消连接线
      },
      'expand_selected_onload': false, //加载完成后默认展开所有选中节点true为选中 false为不展开
      "check_callback": true,
      "multiple": false,
    },
    "checkbox": {
      "keep_selected_style": false,
      "three_state": false,
      "tie_selection": false,
      "multi": false,
      "whole_node": false
    },

    "plugins": ["wholerow", "checkbox"]
  }).on('select_node.jstree', function(event, data) {
    refreshTreeNode_zfsrep_recv(target, data.node, data);
    if (fn && typeof fn === "function") {
      fn();
    }

  }).on('changed.jstree', function(event, data) {

  }).on('check_node.jstree', function(event, data) {
    var ref = jQuery(target).jstree(true);
    var nodes = ref.get_checked();
    jQuery(sf).val(data.node.text);
    jQuery.each(nodes, function(i, nd) {
      if (nd != data.node.id)
        ref.uncheck_node(nd);
    });
    var cklen = jQuery('#jv-filecontent .jstree-checked').length;
    if (cklen) {
      jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub');
    } else {
      jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub_disabled');
    }

  }).on('uncheck_node.jstree', function(event, data) {
    var cklen = jQuery('#jv-filecontent .jstree-checked').length;
    jQuery(sf).val('');
    if (cklen) {
      jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub');
    } else {
      jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub_disabled');
    }
  });
}

function initsendpagedata() {
  jQuery('#jv-taskname').val(sendtaskdata.caption || '').attr('disabled', true);

  jQuery('#jv-erase').prop('checked', sendtaskdata.erase);
  jQuery('#jv-encrypt').prop('checked', sendtaskdata.encrypt);
  jQuery('#jv-encryptkey').prop('checked', sendtaskdata.encryptkey);
  jQuery('#jv-increment').prop('checked', sendtaskdata.increment);

  if (sendtaskdata.action == 2) {
    jQuery('input[value=sshserver]').prop('checked', true);
    jQuery('#jv-sshserver-host').val(sendtaskdata.host);
    jQuery('#jv-sshserver-port').val(sendtaskdata.port);
    jQuery('#jv-sshserver-username').val(sendtaskdata.username);
    jQuery('#jv-sshserver-password').val(sendtaskdata.password);
    jQuery('#jv-sendtask-nextbtn2-2').attr('class', 'unas_button_sub');
    jQuery('#jv-localfolderval-recv').val('');
  } else {
    jQuery('input[value=localfolder]').prop('checked', true);
    jQuery('#jv-localfolderval-recv').val(sendtaskdata.path);
    jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub');
  }

  if (sendtaskdata.schedules.length) {
    jQuery('#jv-timingtype').val(1);
    jQuery('#jv-timingitemcon').show();
    var h = sendtaskdata.schedules[0].hours[0];
    var m = sendtaskdata.schedules[0].minutes[0];
    var ms = sendtaskdata.schedules[0].months[0];
    var d = sendtaskdata.schedules[0].days[0];
    var y = sendtaskdata.schedules[0].years[0];
    jQuery('#jv-recvtask-date').val(y + '/' + ms + '/' + d);
    jQuery('#recvtask_hours').val(h);
    jQuery('#recvtask_minutes').val(m);

  } else {
    jQuery('#jv-timingtype').val(0);
    jQuery('#jv-timingitemcon').hide();
  }

  jQuery('#jv-sendtask-nextbtn1, #jv-sendtask-nextbtn3').attr('class', 'unas_button_sub');
}


jQuery(document).ready(function() {

  jQuery('#jv-taskname, #jv-sshserver-host, #jv-sshserver-port, #jv-sshserver-username, #jv-sshserver-password').bind('input propertychange', function(e) {
    var taskname = jQuery('#jv-taskname').val();
    var action = jQuery('input[name=sendto]:checked').val() == 'localfolder' ? 4 : 2;
    var host = jQuery('#jv-sshserver-host').val();
    var port = jQuery('#jv-sshserver-port').val();
    var username = jQuery('#jv-sshserver-username').val();
    var password = jQuery('#jv-sshserver-password').val();
    if (action == 4) {
      if (taskname) {
        if (tasknamelist.includes(taskname.toLowerCase())) {
          jQuery('#jv-taskname').attr('class', 'unas_input_error').attr('title', UNAS._('The task name already exists'));
          jQuery('#jv-sendtask-nextbtn1').attr('class', 'unas_button_sub_disabled');
        } else {
          jQuery('#jv-sendtask-nextbtn1').attr('class', 'unas_button_sub');
          jQuery('#jv-taskname').attr('class', 'unas_input').attr('title', '');
        }
      } else {
        jQuery('#jv-sendtask-nextbtn1').attr('class', 'unas_button_sub_disabled');
      }

    } else {
      if (taskname && host && port && username && password) {
        jQuery('#jv-sendtask-nextbtn1').attr('class', 'unas_button_sub');
      } else {
        jQuery('#jv-sendtask-nextbtn1').attr('class', 'unas_button_sub_disabled');
      }
    }

  });

  jQuery('input[name=sendto]').click(function() {
    var action = jQuery(this).val() == 'localfolder' ? 4 : 2;
    var taskname = jQuery('#jv-taskname').val();
    var host = jQuery('#jv-sshserver-host').val();
    var port = jQuery('#jv-sshserver-port').val();
    var username = jQuery('#jv-sshserver-username').val();
    var password = jQuery('#jv-sshserver-password').val();
    if (action == 4) {
      if (taskname) {
        jQuery('#jv-sendtask-nextbtn1').attr('class', 'unas_button_sub');
      } else {
        jQuery('#jv-sendtask-nextbtn1').attr('class', 'unas_button_sub_disabled');
      }

    } else {
      if (taskname && host && port && username && password) {
        jQuery('#jv-sendtask-nextbtn1').attr('class', 'unas_button_sub');
      } else {
        jQuery('#jv-sendtask-nextbtn1').attr('class', 'unas_button_sub_disabled');
      }
    }

  })

  jQuery("#jv-selrecvsnapscontent, #jv-selrecvpoolcontent, #jv-selecttargetpoolcontent-recvtask, #jv-localfolderpage").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });

  var sel_hour = jQuery('#recvtask_hours');
  var sel_minutes = jQuery('#recvtask_minutes');

  for (var i = 0; i < 24; i++) {
    sel_hour.append('<option value="' + i + '">' + i + '</option>');
  }
  for (var i = 0; i < 60; i++) {
    sel_minutes.append('<option value="' + i + '">' + i + '</option>');
  }

  var now = new Date();
  var year = now.getFullYear();
  var month = addTimeZero_send(now.getMonth() + 1);
  var day = addTimeZero_send(now.getDate());
  jQuery('#jv-recvtask-date').val(year + '/' + month + '/' + day);


  if (widData.recvtask.type == 'edit') {
    initsendpagedata();
  }

  initTreeData_zfsrep_recv('#select-file-jstree', '#jv-localfolderval-recv', function() {

  });

  recvtask_zfsrep_alload();

})
