<?php
// *** 请注意文件字符集应为 UTF-8 ***
// echo __FILE__, "#", __LINE__, "<br/>\n"; // 调试语句
//
// ----------------------------------------------------------------------------
setlocale(LC_CTYPE, "UTF8", "en_US.UTF-8");

///---INTERFACE-METHODS---BEGIN---///
function zfs_get_spare(){
    // 引入全局变量，此处不要修改
    global $request;
    global $respond;

    $ncDisk = new NCDisk();
    $spares = [];
    foreach( $ncDisk->overall() as $key=>$obj )
    {
        if ( $obj["inuse"] <= 0 )
        {
            $spares[] = [
                "device"    => $obj["dev"],
                "size"  => \UNAS\Disk\HumanReadable(intval($obj["size"] / 1024)),
                "type"   => $obj["tran"] ? $obj["tran"] : $obj["model"],
                "vendor" => $obj["vendor"],
                "model"  => $obj["model"],
                "state"  => true,
            ];
        }
    }

    $respond->results = $spares;
    $respond->err = ERR_SUCCEED;
    return true;
}
///---INTERFACE-METHODS---END---///
?>
