<?php
    // 字符集请设置为 UTF-8
    // FriendSafe2 Core 错误代码。如有出入，以 FS2Core 版为准
    define("ERR_SUCCEED"       ,    0); ///< 正确 / 正常 / 成功
    define("ERR_FAILED"        , 9999); ///< 打开失败 / 操作失败 / 连接失败
    define("ERR_TIMEOUT"       , 9998); ///< 操作超时
    define("ERR_NO_INPUT"      , 9997); ///< 缺少必要的输入 / 必输项遗漏
    define("ERR_DAMAGE"        , 9996); ///< 损坏（文件等）
    define("ERR_PARAMS"        , 9995); ///< 参数内容错误
    define("ERR_NOT_EXISTS"    , 9994); ///< 不存在
    define("ERR_EXISTS"        , 9993); ///< 已经存在
    define("ERR_BUSY"          , 9992); ///< 忙 / 操作被忽略
    define("ERR_LOAD"          , 9991); ///< 读取失败 / 装载失败
    define("ERR_SAVE"          , 9990); ///< 写入失败 / 保存失败
    define("ERR_CONTENT"       , 9989); ///< 内容错误 / 内容无法识别
    define("ERR_AUTHORIZE"     , 9988); ///< 认证失败，或权限不足
    define("ERR_SYSTEM"        , 9987); ///< 系统错误
    define("ERR_LOCKED"        , 9986); ///< 已经锁定
    define("ERR_NOT_ACTIVE"    , 9985); ///< 尚未激活
    define("ERR_NOT_LOGIN"     , 9984); ///< 尚未登录
    define("ERR_NOT_LOGGED_IN" , 9984); ///< 尚未登录
    define("ERR_NOT_SCENE"     , 9983); ///< 场景错误
    define("ERR_USED"          , 9982); ///< 已经使用过了，或没有使用的配额了
    define("ERR_UNCOOLED"      , 9981); ///< 尚未完全冷却
    define("ERR_MAINTENANCE"   , 9980); ///< 维护状态，请稍候再使用
    define("ERR_LOGIN_OUTSIDE" , 9979); ///< 已在别处登录
    define("ERR_SCRIPT_FAILED" , 9978); ///< 脚本执行错误
    define("ERR_SERVER_OFFLINE", 9977); ///< 服务器离线或异常
    define("ERR_SCENE_EXISTS"  , 9976); ///< 已经处于场景中 / 应先退出当前场景
    define("ERR_SQLERROR"      , 9975); ///< 数据库操作发生错误
    define("ERR_INCOMPATIBLE"  , 9974); ///< 系统不兼容或不支持的请求
    define("ERR_NOT_ENOUGH"    , 9973); ///< 不足或不够
    define("ERR_REQUEST_FAILED", 9972); ///< 无效请求，或无权执行该指令
    define("ERR_OFFLINE"       , 9971); ///< 离线或已断开连接
    define("ERR_CONFIG"        , 9970); ///< 配置错误
    define("ERR_CREATE"        , 9969); ///< 创建失败（多用于文件）
    define("ERR_CHANGE"        , 9968); ///< 修改失败（多用于文件）
    define("ERR_CHANGED"       , 9967); ///< 被替换或被覆盖了
    define("ERR_UNCHANGED"     , 9966); ///< 未修改，或未被替换
    define("ERR_DELETE"        , 9965); ///< 删除失败（多用于文件）
    define("ERR_CANCEL"        , 9964); ///< 被取消，这个不一定是错误
    define("ERR_UNKNOWN"       , 9963); ///< 未知。可能不是错误
    define("ERR_UNTREATED"     , 9962); ///< 未处理/未开始。可能不是错误
    define("ERR_CORRELATIVE"   , 9961); ///< 存在关联性
    define("ERR_DIFFERENCE"    , 9960); ///< 不同、不一致、存在差异
    define("ERR_VERSION"       , 9959); ///< 版本不一致或不匹配
    define("ERR_READY"         , 9958); ///< 准备状态。不一定是错误
    define("ERR_NO_RESPONSE"   , 9957); ///< 没有响应
    define("ERR_BEHIND"        , 9956); ///< 落后了，被人抢先了
    define("ERR_REDUPLICATED"  , 9955); ///< 重复的
    define("ERR_ENCRYPTION"    , 9954); ///< 加密方式不正确，或无法识别
    define("ERR_PASSWORD"      , 9953); ///< 密码错误
    define("ERR_UNCCGDPT"      , 9952); ///< 授权目录未选择或授权对象未选择。
    define("ERR_DEVICE"        , 9951); ///< 设备不匹配或不兼容
    define("ERR_FUNDS"         , 9950); ///< 账户余额不足，或服务已经到期
    define("ERR_LOSED"         , 9949); ///< 操作失败
    define("ERR_EXPIRED"       , 9948); ///< 已经过期失效
    define("ERR_OUTOFRANGE"    , 9947); ///< 不在有效范围
    define("ERR_STATE"         , 9946); ///< 状态不正确
    define("ERR_STEP"          , 9945); ///< 进度不正确
    define("ERR_RESTRICT"      , 9944); ///< 约束条件不符合
    define("ERR_ESCAPED"       , 9943); ///< 强制退出或成功逃脱
    define("ERR_LIMIT"         , 9942); ///< 达到限制
    define("ERR_LIMITMAX"      , 9941); ///< 达到最大限制
    define("ERR_LIMITMIN"      , 9940); ///< 达到最小限制
    define("ERR_NO_CONFIG"     , 9939); ///< 没有配置
    define("ERR_SHUTDOWN"      , 9938); ///< 已关机或准备关机
    define("ERR_CLOSED"        , 9937); ///< 已经关闭
    define("ERR_FULL"          , 9936); ///< 已满
    define("ERR_OVERFLOW"      , 9935); ///< 超出、超过、溢出
    define("ERR_DOING"         , 9934); ///< 正在执行中
    define("ERR_WAITING"       , 9933); ///< 正在等待中
    define("ERR_NOT_ACHIEVED"  , 9932); ///< 目标没有达成
    define("ERR_UNNECESSARY"   , 9931); ///< 不需要处理，无须此操作
    define("ERR_FORBID"        , 9930); ///< 禁止，不允许
    define("ERR_LEVEL"         , 9929); ///< 等级不符，或未达到要求
    define("ERR_EMPTY"         , 9928); ///< 空/零
    define("ERR_NOTOPEN"       , 9927); ///< 未开放/未准备就绪
    define("ERR_RESERVED"      , 9926); ///< 保留的
    define("ERR_WRONGFUL"      , 9925); ///< 不合法(轻度非法，一般允许继续执行)
    define("ERR_ILLEGAL"       , 9924); ///< 非法(比不合法更严重，往往不允许继续执行)
    define("ERR_IDENTICAL"     , 9923); ///< 完全相同的，一致的，没有变化的
    define("ERR_BIND"          , 9922); ///< 绑定相关
    define("ERR_UNBIND"        , 9921); ///< 解绑相关
    define("ERR_CONNECT"       , 9920); ///< 连接失败 / 无法连接
    define("ERR_SECRETKEY"     , 9919); ///< 密钥错误 / 获取密钥失败
    define("ERR_PHONENO"       , 9918); ///< 电话号码错误或非法
    define("ERR_CODEVERFIY"    , 9917); ///< 验证码错误或已经失效
    define("ERR_WRITE"         , 9916); ///< 写入失败
    define("ERR_READ"          , 9915); ///< 读取失败
    define("ERR_FORMAT"        , 9914); ///< 数据格式错误或无法识别
    define("ERR_PROGRESS"      , 9913); ///< 进展、进度。一般不表示错误
    define("ERR_INVALID"       , 9912); ///< 无效的，不可用的
    define("ERR_RENAME"        , 9911); ///< 重命名失败 / 更名失败
    define("ERR_MOVEFROM"      , 9910); ///< 移动失败 / 移动源错误
    define("ERR_MOVETO"        , 9909); ///< 移动失败
    define("ERR_STORAGE"       , 9908); ///< 存储失败 / 错误，或存储设备异常
    define("ERR_FILEPATH"      , 9907); ///< 文件全路径名
    define("ERR_FILEDRIVER"    , 9906); ///< 驱动器名(仅Windows)
    define("ERR_DIRECTORY"     , 9905); ///< 文件目录
    define("ERR_FOLDER"        , 9904); ///< 文件夹
    define("ERR_FILENAME"      , 9903); ///< 文件全名(含扩展名)
    define("ERR_FILEBASENAME"  , 9902); ///< 文件名(不含扩展名)
    define("ERR_FILESUFFIX"    , 9901); ///< 文件扩展名(不含前面的.)
    define("ERR_EXTEND"        , 9900); ///< 扩展失败 / 延伸失败
    define("ERR_INOPERATIVE"   , 9899); ///< 非工作状态 / 无法工作状态
    define("ERR_EXECUTE"       , 9898); ///< 执行/运行失败或错误
    define("ERR_OPEN"          , 9897); ///< 打开失败
    define("ERR_RESIDUAL"      , 9896); ///< 存在残留信息。一般不表示错误
    define("ERR_PARTLY_SUCCEED", 9895); ///< 部分成功
    define("ERR_SIGNATURE"     , 9894); ///< 签名错误
    define("ERR_LAUNCH"        , 9893); ///< 启动或执行失败
    define("ERR_COMMUNICATION" , 9892); ///< 通讯失败或协议无效
    define("ERR_UNDEFINED"     , 9891); ///< 没有定义 / 尚未定义
    define("ERR_REPAIRING"     , 9890); ///< 未完成 / 正在修复中
    define("ERR_MOBILE"        , 9889); ///< 手机号错误或非法
    define("ERR_SMSCODE"       , 9888); ///< 手机短信验证码错误或无效
    define("ERR_NOT_FOUND"     , 9887); ///< 没有找到
    define("ERR_NO_ACCESS"     , 9886); ///< 拒绝访问 / 禁止访问
    define("ERR_MISSING"       , 9885); ///< 无此功能(接口缺失、遗漏、系统不支持等)
    define("ERR_NO_PERMISSION" , 9884); ///< 缺少权限 / 无此权限
    define("ERR_BETRAY_LOGIC"  , 9883); ///< 违反制定的相关逻辑
    define("ERR_MACHINE"       , 9882); ///< 机器无法使用 / 无法适用 / 机器故障等
    define("ERR_IDLE"          , 9881); ///< 空闲的 / 空置的
    define("ERR_METHOD"        , 9880); ///< 方法
    define("ERR_MOUNT"         , 9879); ///< 挂载
    define("ERR_UMOUNT"        , 9878); ///< 卸载
    define("ERR_DEVELOPING"    , 9877); ///< 正在开发中，尚未完成，暂不可用
    define("ERR_ACCEPT"        , 9876); ///< 接受 / 同意 / 认可
    define("ERR_MISMATCHING"   , 9875); ///< 不匹配 / 不适用 / 不兼容 / 不可用
    define("ERR_LIMITATIONS"   , 9874); ///< 功能受限 / 试用版/评估版的功能限制
    define("ERR_VIRTUALMACHINE", 9873); ///< 虚拟机 / 虚拟设备
    define("ERR_LOST"          , 9872); ///< 丢失 / 数据在处理过程中突然丢失了(常见于多线程时对同一数据进行处理)
    define("ERR_RUNNING"       , 9871); ///< 正在运行中 / 正在执行中
    define("ERR_CONFLICT"      , 9870); ///< 存在冲突
    define("ERR_SETTING"       , 9869); ///< 应用配置错误或遗漏
    define("ERR_ENABLED"       , 9868); ///< 已启用
    define("ERR_DISABLED"      , 9867); ///< 已禁用
    define("ERR_SYSTEMCRASH"   , 9866); ///< 系统崩溃 / 极端故障
    define("ERR_LOCK"          , 9865); ///< 锁定 / 已锁定
    define("ERR_UNLOCK"        , 9864); ///< 未锁定 / 已解锁
    define("ERR_CLASH"         , 9863); ///< 冲突 / 矛盾

?>