var taskWin = window.top.UNAS.GetWindow('jv-createsendtaskWindow');
var widData = taskWin.options;
var sendtaskdata = widData.sendtask.info;

function zfssnapshot_pools_remote() {
  var host = jQuery('#jv-sshserver-host').val();
  var port = jQuery('#jv-sshserver-port').val();
  var username = jQuery('#jv-sshserver-username').val();
  var password = jQuery('#jv-sshserver-password').val();
  jQuery('#jv-sendtask-nextbtn3').attr('class', 'unas_button_sub_disabled');
  jQuery.ajax({
    url: '/wmi/',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'zfsrep_pools_remote',
      "params": {
        host: host,
        port: +port,
        username: username,
        password: password
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      jQuery('#jv-targetpoolhost').empty();
      if (res.err == 0) {
        var info = res.results || {};
        var i = 0
        for (var v in info) {
          if (info.hasOwnProperty(v)) {
            var tp_ = info[v];
            var pooldom = zfsTemplateAppend('#jv-targetpoolhost', 'jvt-targetpoolitem-sendtask', 'jvt-targetpoolitem-sendtask-' + i);
            pooldom.find('.poolname').text(v || '--');

            if (widData.sendtask.type == 'edit') {
              if (sendtaskdata.path == v) {
                pooldom.find('input[name=targetpool]').prop('checked', true);
              }
            }

            pooldom.find('input[name=targetpool]').val(v).on('click', function() {
              if (this.checked) {
                jQuery('#jv-sendtask-nextbtn3').attr('class', 'unas_button_sub');
              }
            });
          }
          i++;
        }
        if (!jQuery('#jv-targetpoolhost').html()) {
          jQuery('#jv-targetpoolhost').html('<div class="nullpoolhost unas-flex">' + UNAS._('No pool available')+ '</div>');
        }
      } else {
        errcode[res.err] && (send_reqstatus && alert(errcode[res.err]));
      }
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      send_reqstatus && alert(textStatus);
    }
  })

}

function zfssnapshot_mission_append_sendtask() {
  // var dataset = jQuery('#jv-poolhost-sendtask input[name=dataset]:checked');
  // var pnode = dataset.closest('div.pool-datase-titem');
  var timingtype = jQuery('#jv-timingtype').val();

  var caption = jQuery('#jv-taskname').val();
  var action = jQuery('input[name=sendto]:checked').val() == 'localfolder' ? 3 : 1;

  var pool = snapshot_zpoolname; //pnode.find('.poolname').text();
  var name = snapshot_zfilesysname; //dataset.val();

  var path = jQuery('#jv-targetpoolhost input[name=targetpool]:checked').val();
  var host = jQuery('#jv-sshserver-host').val();
  var port = jQuery('#jv-sshserver-port').val();
  var username = jQuery('#jv-sshserver-username').val();
  var password = jQuery('#jv-sshserver-password').val();
  var schedules = [];

  jQuery('#jv-sendtimehost tr').each(function(i, e) {
    var h = jQuery(e).attr('h');
    var m = jQuery(e).attr('m');
    var w = jQuery(e).attr('week');
    var d = jQuery(e).attr('days');
    if (w) {
      schedules.push({
        hours: [+h],
        minutes: [+m],
        weeks: [+w]
      })
    } else if (d) {
      schedules.push({
        hours: [+h],
        minutes: [+m],
        days: [+d]
      })
    } else {
      schedules.push({
        hours: [+h],
        minutes: [+m]
      })
    }
  })

  if (timingtype == "0") {
    schedules = [];
  }

  var params = {
    caption: caption, //任务名称
    action: action, //1.send pool, 2.recv pool, 3.send file, 4.recv file
    pool: pool, //本地的 pool
    name: name, //本地的 dataset
    increment: jQuery('#jv-increment').prop('checked') ? 1 : 0, // 当前不用  1.增量 2.全量
    erase: jQuery('#jv-erase').prop('checked') ? 1 : 0, //当前不用
    encrypt: jQuery('#jv-encrypt').prop('checked') ? 1 : 0, //当前不用
    encryptkey: jQuery('#jv-encryptkey').prop('checked') ? 1 : 0, //当前不用
    schedules: schedules //时间
  }

  if (action == 1) {
    params['path'] = path; //云机上的 pool 名
    params['host'] = host; //云机地址
    params['port'] = port; //云机端口 （ssh）
    params['username'] = username; //云机账号
    params['password'] = password; //云机密码
  } else {
    params['path'] = jQuery('#jv-localfolderval').val();
  }

  var cmd = 'zfsrep_mission_append';
  if (widData.sendtask.type == 'edit') {
    cmd = 'zfsrep_mission_change';
    params['msnno'] = sendtaskdata.msnno;
  }

  jQuery.ajax({
    url: '/wmi/',
    data: JSON.encode({
      "token": UToken,
      "cmd": cmd,
      "params": params
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {

      if (res.err == 0) {
        MUI.closeWindow($('jv-createsendtaskWindow'));
        zfssnapshot_mission_alload();
      } else {
        alert(res.errmsg);
      }
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function zfssnapshot_setsendtaskstep(i) {
  jQuery('.jvc-set-step').hide();
  jQuery('#jv-set-step-' + i).fadeIn();
  var type = jQuery("input[name='sendto']:checked").val();
  jQuery('#jv-' + type + '-content').show();
  if (jQuery('#jv-sshserver-content').is(':hidden')) {
    send_reqstatus = 0;
  }else {
    send_reqstatus = 1;
  }
  console.log(send_reqstatus);
}

function zfssnapshot_showdatasetlist_bdrtask() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  var pnode = that.closest('div.pool-datase-titem');
  that.toggleClass('pool-o');
  pnode.find('.datasetlist').slideToggle();
}

function zfssnapshot_addSendTime(h, m, w_i, days, t, i) {

  var i = i || new Date().getTime();
  var h = h || jQuery('#sendtask_hours').val();
  var m = m || jQuery('#sendtask_minutes').val();
  var w_i = w_i || jQuery('#sendtask_weeks').val();
  var days = days || jQuery('#sendtask_days').val();
  var timetype = t || jQuery('input[name=schedule_type]:checked').val();

  var weekArray = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
  var week = weekArray[w_i];

  var timetext = '';
  switch (timetype) {
    case 'Daily':
      timetext = UNAS._('Daily') + ' ' + addTimeZero_zfssnapshot(h) + ':' + addTimeZero_zfssnapshot(m);
      break;
    case 'Weekly':
      timetext = UNAS._(week) + ' ' + addTimeZero_zfssnapshot(h) + ':' + addTimeZero_zfssnapshot(m);
      break;
    case 'Monthly':
      timetext = UNAS._('Monthly') + ' ' + days + UNAS._('st') + ' ' + addTimeZero_zfssnapshot(h) + ':' + addTimeZero_zfssnapshot(m);
      break;
    default:
  }

  var f = 0;
  jQuery('#jv-sendtimehost tr').each(function(i, e) {
    var content = jQuery(e).find('.timetx').attr('time');
    if (content == timetext) {
      // jQuery(e).remove();
      f = 1;
      return;
    }
  })
  if (f) {
    return;
  }

  var tiemdom = zfsTemplateAppend('#jv-sendtimehost', 'jvt-sendtimeitem', 'jvt-sendtimeitem-' + i);

  tiemdom.find('.timetx').text(timetext).attr('time', timetext);

  switch (timetype) {
    case 'Daily':
      tiemdom.attr('h', h).attr('m', m).attr('week', '').attr('days', '');
      break;
    case 'Weekly':
      var w = (w_i == '0' ? 7 : w_i);
      tiemdom.attr('h', h).attr('m', m).attr('week', w).attr('days', '');
      break;
    case 'Monthly':
      tiemdom.attr('h', h).attr('m', m).attr('week', '').attr('days', days);
      break;
    default:
  }

  tiemdom.find('.unas_icon_delete').on('click', function() {
    jQuery(this).parents('tr').remove();

    if (!jQuery('#jv-sendtimehost tr').children().length) {
      jQuery('#jv-sendtask-nextbtn4').attr('class', 'unas_button_sub_disabled');
    }
  })

  if (jQuery('#jv-sendtimehost tr').children().length) {
    jQuery('#jv-sendtask-nextbtn4').attr('class', 'unas_button_sub');
  }
  // jQuery('#jv-sendtimehost tr').sort(function(a, b) {
  //   var contentA = jQuery(a).find('.timetx').attr('time');
  //   var contentB = jQuery(b).find('.timetx').attr('time');
  //   return (contentA < contentB) ? -1 : (contentA > contentB) ? 1 : 0;
  // }).appendTo('#jv-sendtimehost');

}

function zfssnapshot_setTimeV() {
  var sel_hour = jQuery('#sendtask_hours');
  var sel_minutes = jQuery('#sendtask_minutes');
  var sel_weeks = jQuery('#sendtask_weeks');
  var sel_days = jQuery('#sendtask_days');
  var weekArray = new Array('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday');
  for (var i = 0; i < 24; i++) {
    sel_hour.append('<option value="' + i + '">' + i + '</option>');
  }
  for (var i = 0; i < 60; i++) {
    sel_minutes.append('<option value="' + i + '">' + i + '</option>');
  }
  for (var i = 1; i < 7; i++) {
    sel_weeks.append('<option value="' + i + '">' + UNAS._(weekArray[i]) + '</option>');
  }
  sel_weeks.append('<option value="0">' + UNAS._(weekArray[0]) + '</option>');
  for (var i = 1; i <= 31; i++) {
    sel_days.append('<option value="' + i + '">' + i + '</option>');
  }
}

function refreshTreeNode_zfssnapshot_send(target, node, data) {
  var id = node.id;
  var jsonstr = "[]";
  var jsonarray = eval('(' + jsonstr + ')');
  var ref = jQuery(target).jstree(true);
  jQuery.ajax({
    url: '/apps/zfs/includes/list_dir.php?dir=' + id,
    contentType: 'application/json',
    timeout: 300000,
    dataType: "json",
    success: function(result) {
      var arrays = result || [];
      node.children = [];
      var ch = 0;
      var selected = 0;
      for (var i = 0; i < arrays.length; i++) {
        var icon = '/apps/zfs/js/jstree/images/directory.png';
        if (arrays[i].type != 'dir') {
          icon = '/apps/zfs/js/jstree/images/file.png';
          ch = 1;
        } else {
          ch = 0;
        }
        var checked = false;

        if (arrays[i].path == sendtaskdata.path) {
          checked = true;
        }

        var ck_is = ch ? "no_checkbox" : '';

        var arr = {
          "id": arrays[i].path,
          "text": arrays[i].name,
          "parent": arrays[i].path,
          "type": arrays[i].type,
          'icon': icon,
          'state': {
            "checked": checked
          },
          'a_attr': {
            'class': ck_is
          }
        }

        ref.create_node(node, arr, "last");
      }
      ref.open_node(node);

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      //alert(textStatus);

    }
  });
}

function initTreeData_zfssnapshot_send(target, sf, fn) {
  var checked = false;

  if (sendtaskdata.path == '/mnt') {
    checked = true;
  }

  jQuery(target).jstree({
    "core": {
      'data': function(obj, callback) {
        var jsonstr = "[]";
        var jsonarray = eval('(' + jsonstr + ')');
        var url = 'xxxxxxxxxxxx/xxxxxxxxx';
        var arr = {
          "id": '/mnt',
          "text": '/mnt',
          "parent": "#",
          "icon": '/apps/zfs/js/jstree/images/directory.png',
          "type": "dir",
          "state": {
            // "opened": false,
            // "selected": false
            "checked": checked
          }
          // 'a_attr': {'class': "no_checkbox"}
        }
        jsonarray.push(arr);


        callback.call(this, jsonarray);

      }.bind(this),
      "themes": {
        "variant": "large", //加大
        "ellipsis": true, //文字多时省略
        dots: true //取消连接线
      },
      'expand_selected_onload': false, //加载完成后默认展开所有选中节点true为选中 false为不展开
      "check_callback": true,
      "multiple": false,
    },
    "checkbox": {
      "keep_selected_style": false,
      "three_state": false,
      "tie_selection": false,
      "multi": false,
      "whole_node": false
    },

    "plugins": ["wholerow", "checkbox"]
  }).on('select_node.jstree', function(event, data) {
    refreshTreeNode_zfssnapshot_send(target, data.node, data);

    if (fn && typeof fn === "function") {
      fn();
    }

  }).on('changed.jstree', function(event, data) {

  }).on('check_node.jstree', function(event, data) {
    var ref = jQuery(target).jstree(true);
    var nodes = ref.get_checked();

    jQuery(sf).val(data.node.id);

    jQuery.each(nodes, function(i, nd) {
      if (nd != data.node.id)
        ref.uncheck_node(nd);
    });
    var cklen = jQuery('#jv-filecontent .jstree-checked').length;
    if (cklen) {
      jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub');
    } else {
      jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub_disabled');
      jQuery(sf).val('');
    }

  }).on('uncheck_node.jstree', function(event, data) {
    var cklen = jQuery('#jv-filecontent .jstree-checked').length;

    if (cklen) {
      jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub');
    } else {
      jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub_disabled');
      jQuery(sf).val('');
    }
  });
}

function zfssnapshot_timingtypesend_on() {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.target);
  if (+that.val()) {
    jQuery('#jv-timingitemcon').show();
    jQuery('#jv-sendtimehostcontent').show();
    if (jQuery('#jv-sendtimehost tr').children().length) {
      jQuery('#jv-sendtask-nextbtn4').attr('class', 'unas_button_sub');
    } else {
      jQuery('#jv-sendtask-nextbtn4').attr('class', 'unas_button_sub_disabled');
    }

  } else {
    jQuery('#jv-timingitemcon').hide();
    jQuery('#jv-sendtimehostcontent').hide();
    jQuery('#jv-sendtask-nextbtn4').attr('class', 'unas_button_sub');
  }

}

function zfssnapshot_initsendpagedata() {
  jQuery('#jv-taskname').val(sendtaskdata.caption || '').attr('disabled', true);
  jQuery('#jv-snapprefixname').val(sendtaskdata.snapname || '').attr('disabled', true);

  jQuery('#jv-erase').prop('checked', sendtaskdata.erase);
  jQuery('#jv-encrypt').prop('checked', sendtaskdata.encrypt);
  jQuery('#jv-encryptkey').prop('checked', sendtaskdata.encryptkey);
  jQuery('#jv-increment').prop('checked', sendtaskdata.increment);

  if (sendtaskdata.action == 1) {
    jQuery('input[value=sshserver]').prop('checked', true);
    jQuery('#jv-sshserver-host').val(sendtaskdata.host);
    jQuery('#jv-sshserver-port').val(sendtaskdata.port);
    jQuery('#jv-sshserver-username').val(sendtaskdata.username);
    jQuery('#jv-sshserver-password').val(sendtaskdata.password);
    zfssnapshot_pools_remote();
    jQuery('#jv-sendtask-nextbtn3').attr('class', 'unas_button_sub');
    jQuery('#jv-localfolderval').val('');
  } else {
    jQuery('input[value=localfolder]').prop('checked', true);
    jQuery('#jv-sendtask-nextbtn2-1').attr('class', 'unas_button_sub');
    jQuery('#jv-localfolderval').val(sendtaskdata.path);
  }

  if (sendtaskdata.schedules.length) {
    jQuery('#jv-timingtype').val(1);
    for (var i = 0; i < sendtaskdata.schedules.length; i++) {
      var h = sendtaskdata.schedules[i].hours;
      var m = sendtaskdata.schedules[i].minutes;
      var w_i = sendtaskdata.schedules[i].weeks;
      var days = sendtaskdata.schedules[i].days;
      h = (h ? h.toString() : h);
      m = (m ? m.toString() : m);
      w_i = (w_i ? w_i.toString() : w_i);
      days = (days ? days.toString() : days);

      var t = 'Daily';
      if (w_i) {
        t = 'Weekly';
      } else if (days) {
        t = 'Monthly';
      } else {
        t = 'Daily';
      }
      zfssnapshot_addSendTime(h, m, w_i, days, t, i);
      jQuery('#jv-timingitemcon').show();
    }
  } else {
    jQuery('#jv-timingtype').val(0);
    jQuery('#jv-timingitemcon').hide();
  }

  jQuery('#jv-zfssnapshot-nextbtn1, #jv-sendtask-nextbtn2-2, #jv-sendtask-nextbtn4').attr('class', 'unas_button_sub');
}

(function() {

  if (widData.sendtask.type == 'edit') {
    zfssnapshot_initsendpagedata();
  }

  initTreeData_zfssnapshot_send('#select-file-jstree', '#jv-localfolderval', function() {

  });

  zfssnapshot_setTimeV();

  jQuery('#jv-taskname').bind('input propertychange', function(e) {
    var v = jQuery(this).val();
    var snapname = jQuery('#jv-snapprefixname').val();
    if (v) {
      if (zfssnapshot_tasknamelist.includes(v.toLowerCase())) {
        jQuery(this).attr('class', 'unas_input_error').attr('title', UNAS._('The task name already exists'));
        jQuery('#jv-zfssnapshot-nextbtn1').attr('class', 'unas_button_sub_disabled');
      } else {
        jQuery(this).attr('class', 'unas_input').attr('title', '');
        if (snapname) {
          jQuery('#jv-zfssnapshot-nextbtn1').attr('class', 'unas_button_sub');
        } else {
          jQuery('#jv-zfssnapshot-nextbtn1').attr('class', 'unas_button_sub_disabled');
        }
      }
    } else {
      jQuery('#jv-zfssnapshot-nextbtn1').attr('class', 'unas_button_sub_disabled');
    }
  });

  jQuery('#jv-snapprefixname').bind('input propertychange', function(e) {
    var v = jQuery(this).val();
    var taskname = jQuery('#jv-taskname').val();
    if (v && taskname) {
      if (zfssnapshot_tasknamelist.includes(taskname.toLowerCase())) {
        jQuery('#jv-zfssnapshot-nextbtn1').attr('class', 'unas_button_sub_disabled');
      } else {
        jQuery('#jv-zfssnapshot-nextbtn1').attr('class', 'unas_button_sub');
      }
    } else {
      jQuery('#jv-zfssnapshot-nextbtn1').attr('class', 'unas_button_sub_disabled');
    }
  });

  var timeoutId;
  var inputDelay = 500;
  jQuery('#jv-sshserver-host, #jv-sshserver-port, #jv-sshserver-username, #jv-sshserver-password').bind('input propertychange', function(e) {

    if (timeoutId) {
      clearTimeout(timeoutId);
    }
    timeoutId = setTimeout(() => {
      zfssnapshot_pools_remote();
    }, inputDelay);

  });

  jQuery('#sendtask_daily').click(function() {
    jQuery('#sendtask_weeks_cont').attr('style', "display:none");
    jQuery('#sendtask_days_cont').attr('style', "display:none");
    jQuery('#sendtask_days_cont').prop('disabled', false);
  })
  jQuery('#sendtask_weekly').click(function() {
    jQuery('#sendtask_weeks_cont').attr('style', "display:block;");
    jQuery('#sendtask_days_cont').attr('style', "display:none");
    jQuery('#sendtask_weeks').prop('disabled', false);
  })
  jQuery('#sendtask_monthly').click(function() {
    jQuery('#sendtask_weeks_cont').attr('style', "display:none");
    jQuery('#sendtask_days_cont').attr('style', "display:block;");
    jQuery('#sendtask_days').prop('disabled', false);
  })

  jQuery("#jv-selecttargetpoolcontent, #jv-localfolderpage").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
})()
