var IsSelectDevice = false;
var vDevMeetReq = false;
var level_init = ['stripe', 'raidz1', 'raidz2', 'raidz3'];
var level_edit = '';

function formatSize(bytes, decimalPoint) {
  if (bytes == 0) return '0 KB';
  var k = 1024,
    dm = decimalPoint || 2,
    sizes = ['KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB', 'BB'],
    i = Math.floor(Math.log(bytes) / Math.log(k));
  return parseFloat((bytes / Math.pow(k, i)).toFixed(dm)) + ' ' + sizes[i];
}

function getExtendPVsInfo() {
  jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:block");
  jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:block");

  jQuery.ajax({
    // url: "/apps/zfs/includes/index.php",
    // data: JSON.encode({
    //   "cmd": "zfs_get_pvsinfo"
    // }),
    url: "/wmi/index.php",
    data: JSON.encode({
      "cmd": "disk_unoccupied",
      "token": UToken
    }),
    type: "POST",
    async: true,
    timeout: 3000000,
    dataType: "json",
    contentType: 'application/json',
    success: function(result) {
      let data = result.results;
      var v = 0;
      jQuery('#extend_availablepvdev').empty();
      for (var i in data) {
        if (data.hasOwnProperty(i)) {
          var tr = '<tr><td class="sparelist">' +
            '<div class="unas-flex flex-space-between">' +
            '<span class="unas-flex  unas_table_text" style="margin-left: 0;"><div class="unas_checkbox" style="margin-left: 0;"><input type="checkbox" name="zfs_manager_checkextendpv" id="zfs_manager_checkextendpv' + i + '" value="' + data[
              i].dev +
            '" onClick="checkSaveSubmit();" /><label for="zfs_manager_checkextendpv' + i + '"></label></div><span class="font-w">' + UNAS._('##$@zfs@$##Device ID##$@zfs@$##') + '</span></span>' +
            '<span>' + data[i].dev + '</span>' +
            '</div>' +
            '<div class="unas-flex flex-space-between"><span class="font-w">' + UNAS._('##$@zfs@$##Model##$@zfs@$##') + '</span><span class="unas_table_text" >' + data[i].model + '</span></div>' +
            '<div class="unas-flex flex-space-between"><span class="font-w">' + UNAS._('##$@zfs@$##Size##$@zfs@$##') + '</span><span class="unas_table_text">' + data[i].size + '</span></div>' +
            '<div class="unas-flex flex-space-between"><span class="font-w">' + UNAS._('##$@zfs@$##Type##$@zfs@$##') + '</span><span class="unas_table_text">' + data[i].type + '</span></div>' +
            '<div class="unas-flex flex-space-between">' +
            '<div class="unas-flex">' +
            '<input type="radio" name=' + data[i].dev + '" onClick="checkSaveSubmit()" id="member' + data[i].dev + '" checked="checked">' +
            '<span class="font-w" style="margin-left:0.1rem;">' + UNAS._('##$@zfs@$##Member##$@zfs@$##') + '</span>' +
            '</div>' +
            '<div class="unas-flex">' +
            '<input type="radio" name=' + data[i].dev + '" onClick="checkSaveSubmit()" id="spare' + data[i].dev + '">' +
            '<span class="font-w" style="margin-left:0.1rem;">' + UNAS._('##$@zfs@$##Spare##$@zfs@$##') + '</span>' +
            '</div>' +
            '<div class="unas-flex">' +
            '<input type="radio" name=' + data[i].dev + '" onClick="checkSaveSubmit()" id="log' + data[i].dev + '">' +
            '<span class="font-w" style="margin-left:0.1rem;">' + UNAS._('##$@zfs@$##log##$@zfs@$##') + '</span>' +
            '</div>' +
            '<div class="unas-flex">' +
            '<input type="radio" name=' + data[i].dev + '" onClick="checkSaveSubmit()" id="cache' + data[i].dev + '">' +
            '<span class="font-w" style="margin-left:0.1rem;">' + UNAS._('##$@zfs@$##cache##$@zfs@$##') + '</span>' +
            '</div>' +

            '<div class="unas-flex">' +
            '<input type="radio" name=' + data[i].dev + '" onClick="checkSaveSubmit()" id="dedup' + data[i].dev + '">' +
            '<span class="font-w" style="margin-left:0.1rem;">' + UNAS._('##$@zfs@$##Dedup##$@zfs@$##') + '</span>' +
            '</div>' +

            '<div class="unas-flex">' +
            '<input type="radio" name=' + data[i].dev + '" onClick="checkSaveSubmit()" id="special' + data[i].dev + '">' +
            '<span class="font-w" style="margin-left:0.1rem;">' + UNAS._('##$@zfs@$##Special##$@zfs@$##') + '</span>' +
            '</div>' +

            '</div></td></tr>';

          jQuery('#extend_availablepvdev').append(tr);
          v++;
        }
      }

      var nodata = '<td align="center">' +
        '<img style="margin-top:38px;" src="/apps/zfs/images/nodevice_bg.png?v=0.0.1&" alt="">' +
        '<p>' + UNAS._('There are currently no devices available') + '</p>' +
        '</td>';

      if (!jQuery('#extend_availablepvdev').html()) {
        jQuery('#extend_availablepvdev').html(nodata);
      }

      jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(UNAS._(textStatus));
      jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
    }
  });
}
/**
 *  Edit Volume Group
 */
function submit_editZPOOL() {
  if (jQuery("#zfs_editzpool_submit").attr("class") != "unas_button_sub_disabled") {
    jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:block");
    jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:block");
    var extend_pvdevice = [];
    var zpoolname = jQuery.trim(jQuery('#edit_zpoolname').html());
    var selectedDev = []; //list of selected device
    jQuery('input[name="zfs_manager_checkextendpv"]').each(function() {
      if (jQuery(this).prop('checked') == true) {
        extend_pvdevice.push(jQuery(this).val());
        selectedDev.push(jQuery(this).val());
      }
    });
    if (!extend_pvdevice.length) {
      jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
      return false;
    }
    var level = jQuery('#zfs_manager_create_levelselect').val();
    var diskselect = 0;
    var member_device = [];
    var spare_device = [];
    var log_device = [];
    var cache_device = [];
    var dedup_device =[];
    var special_device =[];

    var el = document.getElementsByName('zfs_manager_checkextendpv');
    var len = el.length;
    var logDevCount = 0;
    for (var i = 0; i < len; i++) {
      if (el[i].checked == true) {
        var memberid = "member" + el[i].value;
        if (document.getElementById(memberid).checked == true) {
          member_device.push(el[i].value);
        }
        if (document.getElementById("spare" + el[i].value).checked == true) {
          spare_device.push(el[i].value);
        }
        if (document.getElementById("log" + el[i].value).checked == true) {
          log_device.push(el[i].value);;
          logDevCount++;
        }
        if (document.getElementById("cache" + el[i].value).checked == true) {
          cache_device.push(el[i].value);;
        }
        if(document.getElementById("dedup"+el[i].value).checked == true){
          dedup_device.push(el[i].value);
        }
        if(document.getElementById("special"+el[i].value).checked == true){
          special_device.push(el[i].value);
        }
      }
    }
    var logMirror = 0; //not as mirror for log.
    if (logDevCount > 1) {
      var rr = confirm("Do you want to use devices: [" + log_device + "] as mirror for logs?");
      if (rr) {
        logMirror = 1;
      }
    }
    let data = {
      cmd: 'zfs_zpool_edit',
      params: {
        "zpool": zpoolname,
        "raidLevel": level,
        "pvs": member_device,
        "log_mirror": logMirror,
        "logs": log_device,
        "spares": spare_device,
        "cache": cache_device,
        "extend_pv": extend_pvdevice,
        "dedup" : dedup_device,
        "special" : special_device
      }
    }
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      timeout: 300000,
      dataType: "json",
      contentType: 'application/json',
      success: function(result) {
        let data = result.results;
        if (data) {
          if (data.errorLog == '1' || data.errorSpare == '1' || data.errorCache == '1') {
            //something is wrong, report it.
            alert(UNAS._("Adding device failed!"));
            //refresh window.
            GetZpoolInfo(zpoolname);
          } else {
            var w = window.top.UNAS.GetWindow('EditZpoolWindow');
            w.ProcessEditZpool();
            MUI.closeWindow(parent.document.getElementById('EditZpoolWindow'));
          }
        } else {
          jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
          jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(UNAS._(textStatus));
        jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
        jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
      }
    });
  }
}

function SetScrub() {
  jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:block");
  jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:block");
  var zpoolname = jQuery.trim(jQuery('#edit_zpoolname').html());
  var days = 0; //weekly
  var setScrub = 0; //do not set scrub.
  if (jQuery('#zfs_scrub_weekly').prop('checked')) days = 0; //0 -weekly, 1- biweekly, 2-monthly
  if (jQuery('#zfs_scrub_biweekly').prop('checked')) days = 1;
  if (jQuery('#zfs_scrub_monthly').prop('checked')) days = 2;
  if (jQuery('#create_zfsscrubtask_schedule').is(":checked")) setScrub = 1;
  var hour = 0;
  hour = jQuery('#zfs_scrub_hours option:selected').val(); // 0-23 hour
  let data = {
    cmd: 'zfs_scrub_set',
    params: {
      "zpool": zpoolname,
      "interval": days,
      "hour": parseInt(hour),
      "setScrub": setScrub
    }
  };

  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 300000,
    success: function(data) {
      if (data) {
        var w = window.top.UNAS.GetWindow('EditZpoolWindow');
        w.ProcessEditZpool();
        GetZpoolInfo(zpoolname);
        jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
        jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(UNAS._(textStatus));
      jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
    }
  });
}

function removeSpare(e) {
  unasConfirm({
    msg: UNAS._("Are you sure you want to delete") + "："  + e.name + "?"
  }, function() {
    jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:block");
    jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:block");
    let data = {
      cmd: 'zfs_spare_remove',
      params: {
        "zpool": zpoolname,
        "pv": e.name
      }
    }
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 300000,
      success: function(data) {
        if (data) {
          var w = window.top.UNAS.GetWindow('EditZpoolWindow');
          w.ProcessEditZpool();
          GetZpoolInfo(zpoolname);
        }
      },
      complete: function() {
        jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
        jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(UNAS._(textStatus));
      }
    });
  })
}

function removeLogs(e) {
  unasConfirm({
    msg: UNAS._("Are you sure you want to delete") + "：" + e.name + "?"
  }, function() {
    let data = {
      cmd: 'zfs_log_remove',
      params: {
        "zpool": zpoolname,
        "pv": e.name
      }
    };
    jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:block");
    jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:block");
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 300000,
      success: function(data) {
        if (data) {
          var w = window.top.UNAS.GetWindow('EditZpoolWindow');
          w.ProcessEditZpool();
          GetZpoolInfo(zpoolname);
        }
      },
      complete: function() {
        jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
        jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(UNAS._(textStatus));
      }
    });
  })

}

function removeCache(e) {
  unasConfirm({
    msg: UNAS._("Are you sure you want to delete") + "："  + e.name + "?"
  }, function() {
    let data = {
      cmd: 'zfs_cache_remove',
      params: {
        "zpool": zpoolname,
        "pv": e.name
      }
    }
    jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:block");
    jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:block");
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 300000,
      success: function(data) {
        if (data) {
          var w = window.top.UNAS.GetWindow('EditZpoolWindow');
          w.ProcessEditZpool();
          GetZpoolInfo(zpoolname);
        }
      },
      complete: function() {
        jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
        jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(UNAS._(textStatus));
      }
    });
  })
}

function replaceDevice(e) { //replace a device
  var cwh = getClientWH();
  var CreateZPOOLW = new MUI.Modal({
    id: 'ReplaceDeviceWindow',
    title: UNAS._('##$@zfs@$##Replace Device##$@zfs@$##'),
    modal: true,
    width: cwh.w,
    height: cwh.h, //parseInt(cwh.h * 0.84),
    type: 'modal2',
    addClass: 'mobile-modal',
    modalOverlayClose: false,
    contentURL: '/apps/zfs/m/replace_device.html?v=0.0.1&device=' + e.name + '&zpoolname=' + zpoolname
  });
  CreateZPOOLW.ProcessCreateZpool = function() {
    GetZpoolInfo(zpoolname);
  }

  jQuery('#zfs_btn_replace_Save').attr("style", "display:block"); //show dialog.


}

function attachDevice(e) {
  var cwh = getClientWH();
  var CreateZPOOLW2 = new MUI.Modal({
    id: 'AttachDeviceWindow',
    title: UNAS._('##$@zfs@$##Attach Device##$@zfs@$##'),
    modal: true,
    width: cwh.w,
    height: cwh.h, //parseInt(cwh.h * 0.84),
    type: 'modal2',
    addClass: 'mobile-modal',
    modalOverlayClose: false,
    contentURL: '/apps/zfs/m/attach_device.html?v=0.0.1&device=' + e.name + '&zpoolname=' + zpoolname
  });
  CreateZPOOLW2.ProcessCreateZpool = function() {
    GetZpoolInfo(zpoolname);
  }

}

function detachDevice(e) {
  unasConfirm({
    msg: UNAS._("Are you sure to detach") + ": " + e.name + " ?"
  }, function() {
    let data = {
      cmd: "zfs_pv_detach",
      params: {
        "zpool": zpoolname,
        "pv_old": e.name
      }
    }
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 3000000,
      success: function(data) {
        if (data) {
          GetZpoolInfo(zpoolname);
        } else {
          alert("Detach " + e.name + " failed!");
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })

}

function clickRAID(e) {

}

function clickDevice(e) {

}

function submit_addPoolSnapshot() {
  var zpoolname = jQuery('#edit_zpoolname').html();
  var snap = jQuery.trim(jQuery('#new_pool_snapshot_name').val()).toLowerCase();
  if (jQuery("#new_pool_snapshot_name").attr("class") != "unas_input_error") {
    let data = {
      cmd: 'zfs_snapshot_zpool_new',
      params: {
        "zpool": zpoolname,
        "name": snap
      }
    }
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 3000000,
      success: function(data) {
        if (data) {
          GetZpoolInfo(zpoolname);
          var w = window.top.UNAS.GetWindow('EditZpoolWindow');
          w.ProcessEditZpool();
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  }

}

function submit_SnapshotAndSend() {
  var sendToDir = jQuery('#unaszfs_pool_snapshot_folder_select').val();

  unasConfirm({
    msg: UNAS._("Take a snapshot of ") + zpoolname + UNAS._(" and send to :") + sendToDir
  }, function() {
    let data = {
      cmd: 'zfs_snapshot_send',
      params: {
        "zpool": zpoolname,
        "sendto": sendToDir
      }
    }
    jQuery.ajax({
      url: "/apps/zfs/includes/index.php",
      type: "POST",
      async: true,
      data: JSON.encode(data),
      dataType: "json",
      contentType: 'application/json',
      timeout: 3000000,
      success: function(data) {
        if (data) {
          GetZpoolInfo(zpoolname);
          var w = window.top.UNAS.GetWindow('EditZpoolWindow');
          w.ProcessEditZpool();
        }
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      }
    });
  })
}

function ZFSReceive() {
  jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:block");
  jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:block");
  var zfilesysname = jQuery('#zfs_receive_dataset').val();
  var snapshot = jQuery('#selected-snapshot-file').val();
  if (snapshot == "") {
    alert('Please select a snapshot to reveive.');
    jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
    jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
    return;
  }
  let data = {
    cmd: 'zfs_snapshot_receive',
    params: {
      "zpool": zpoolname,
      "zfilesys": zfilesysname,
      "snap_name": snapshot
    }
  }
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    data: JSON.encode(data),
    dataType: "json",
    contentType: 'application/json',
    timeout: 300000,
    success: function(data) {
      if (data) {

        var w = window.top.UNAS.GetWindow('EditZpoolWindow');
        //w.ProcessEditZpool();
        GetZpoolInfo(zpoolname);
        jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
        jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(UNAS._(textStatus));
      jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
    }
  });
}

function toggleFiletree_zfs() {
  if (jQuery('#select-snapshot-file').css('display') === 'none') {
    var mnt = '<ul class="isoJqueryFileTree" style=""><li class="directory collapsed"><a href="#" rel="/mnt">/mnt</a></li></ul>';
    jQuery('#select-snapshot-file-jstree').html(mnt);
    jQuery('#select-snapshot-file').show();
    bindTree_zfs(jQuery('#select-snapshot-file-jstree'));
  } else {
    jQuery('#select-snapshot-file-jstree').html('');
    jQuery('#select-snapshot-file').hide();
  }
}

function loadTree_zfs(d) {
  jQuery(d).parent().addClass('wait');
  var data = "dir=" + jQuery(d).attr('rel');
  jQuery.ajax({
    url: '/apps/zfs/includes/list_dir.php?dir=' + jQuery(d).attr('rel'),
    contentType: 'application/json',
    timeout: 30000,
    success: function(data) {
      data = JSON.parse(data);
      jQuery(d).parent().removeClass('wait');
      var subTree = '<ul class="isoJqueryFileTree collapsed" style="">';
      if (data.length === 0) {
        subTree += '<li><i>' + UNAS._('##$@zfs@$##Empty directory...##$@zfs@$##') + '</i></li>';
      } else {
        data.forEach(function(v) {
          if (v.type == 'dir') {
            subTree += '<li class="directory collapsed">';
            subTree += '<a href="#" rel="' + v.path + '">' + v.name + '</a>';
            subTree += '</li>';
          } else if (v.type == 'file') {
            subTree += '<li class="file ext_iso">';
            subTree += '<a href="#" rel="' + v.path + '">' + v.name + '</a>';
            subTree += '</li>';
          }
        });
      }
      subTree += '</ul>';
      jQuery(d).parent().append(subTree);
      jQuery(d).parent().find('ul').slideDown('fast', function() {
        jQuery(d).parent().removeClass('collapsed').addClass('expanded');
      });
      bindTree_zfs(jQuery(d).parent().find('ul'));
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      jQuery(d).parent().removeClass('wait');
      alert(textStatus);
    }
  });
}

function bindTree_zfs(d) {
  jQuery(d).find('li a').bind('click', function() {
    if (jQuery(this).parent().hasClass('directory')) {
      if (jQuery(this).parent().hasClass('collapsed')) { // Expand
        loadTree_zfs(jQuery(this));
      } else { // Collapse
        jQuery(this).parent().find('ul').slideUp('fast', function() {
          jQuery(this).parent().removeClass('expanded').addClass('collapsed');
          jQuery(this).parent().find('ul').remove();
        });
      }
    } else {
      jQuery('#selected-snapshot-file').val(jQuery(this).attr('rel'));
      jQuery('#select-snapshot-file-jstree').html('');
      jQuery('#select-snapshot-file').hide();
    }
    return false;
  });
}

function addChanged() {
  var level = jQuery('#zfs_manager_create_levelselect').val();
  var diskselect = 0;
  var el = document.getElementsByName('zfs_manager_checkextendpv');
  var len = el.length;
  for (var i = 0; i < len; i++) {
    if (el[i].checked) {
      var memberid = "member" + el[i].value;
      // if(document.getElementById(memberid).checked == true){
      // 	diskselect++;
      // }
      if (el[i].checked == true) {
        diskselect++;
      }
    }
  }
  if (level_init.indexOf(level_edit) > -1) {
    if (diskselect >= 1) {
      vDevMeetReq = true;
    }else {
      vDevMeetReq = false;
    }
  }else {
    if (((level == "stripe") && (diskselect >= 1))
    || ((level == "mirror") && (diskselect >= 2))
    || ((level == "raidz1") && (diskselect >= 3))
    || ((level == "raidz2") && (diskselect >= 4))
    || ((level == "raidz3") && (diskselect >=5))
    || ((level == "draid1") && (diskselect >= 2) )
    || ((level == "draid2") && (diskselect >= 3) )
    || ((level == "draid3") && (diskselect >= 4) )) {
      vDevMeetReq = true;
    } else {
      vDevMeetReq = false;
    }
  }
}

function renderZfilesysmZpoolSubmit() {

  if (IsSelectDevice && vDevMeetReq) {
    jQuery("#zfs_editzpool_submit").attr("class", "unas_button_sub");
  } else {
    jQuery("#zfs_editzpool_submit").attr("class", "unas_button_sub_disabled");
  }
}

function checkSaveSubmit() {
  if (jQuery('input[name="zfs_manager_checkextendpv"]:checked').length > 0) {
    IsSelectDevice = true;
  }
  addChanged();
  renderZfilesysmZpoolSubmit();
}

function GetZpoolInfo(zpoolname) {
  jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:block");
  jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:block");

  let data = {
    cmd: 'zfs_zpool_info',
    params: {
      "zpool": zpoolname
    }
  };
  var schedule = jQuery('#create_zfsscrubtask_schedule').prop('checked');
  jQuery.ajax({
    url: "/apps/zfs/includes/index.php",
    type: "POST",
    async: true,
    dataType: "json",
    contentType: 'application/json',
    data: JSON.encode(data),
    timeout: 300000,
    success: function(result) {
      let data = result.results;
      level_edit = data.level;
      if (level_init.indexOf(data.level) > -1) {
        jQuery('#jv-showraidlevel').hide();
        jQuery('#jv-showpsd').show();
      }else {
        jQuery('#jv-showraidlevel').show();
        jQuery('#jv-showpsd').hide();
      }
      jQuery('#zfs_manager_create_levelselect').val(data.level);

      jQuery('#zpoolname_state').html(data.pool_status.state);
      jQuery('#zpoolname_health').html(data.pool_status.errors);
      jQuery('#zpoolname_scan').html(data.pool_status.scan);
      let scrub = data.scrub || {};

      if (scrub) {
        if (scrub.status || schedule) {
          jQuery('#create_zfsscrubtask_schedule').prop('checked', true);
          jQuery('#zfs_scrub_hours').prop('disabled', false);
          jQuery('#zfs_scrub_weekly').prop('disabled', false);
          jQuery('#zfs_scrub_biweekly').prop('disabled', false);
          jQuery('#zfs_scrub_monthly').prop('disabled', false);
          jQuery('#scrub_set_hours').show();
          jQuery('#zfs_scrub_weekly').show();
          jQuery('#zfs_scrub_biweekly').show();
          jQuery('#zfs_scrub_monthly').show();
          jQuery("#scrub_text_weekly").show();
          jQuery("#scrub_text_biweekly").show();
          jQuery("#scrub_text_monthly").show();
          jQuery('#zfs_scrub_hours').val(scrub.hour);
          jQuery(".scrubitem").show();
        } else {
          jQuery(".scrubitem").hide();
        }
        jQuery("#zfs_set_scrub_button").attr("class", "unas_button_content_disabled").prop('disabled', true);

        if (scrub.interval == 0) {
          jQuery('#zfs_scrub_weekly').attr('checked', true);
        }
        if (scrub.interval == 1) {
          jQuery('#zfs_scrub_biweekly').attr('checked', true);
        }
        if (scrub.interval == 2) {
          jQuery('#zfs_scrub_monthly').attr('checked', true);
        }

      };
      //send to directories
      jQuery('#unaszfs_pool_snapshot_folder_select').empty();
      jQuery.each(data.folders, function(key, value) {
        if (value.path == data.selectedfolder) {
          var str = '<option value="' + value.path + '"  selected>' + value.path + '</option>';

        } else {
          var str = '<option value="' + value.path + '" >' + value.path + '</option>';
        }
        jQuery('#unaszfs_pool_snapshot_folder_select').append(str);
      });
      if (!jQuery('#unaszfs_pool_snapshot_folder_select').html()) {
        jQuery('#jv-snapshotAndSendbtn').attr('class', 'unas_button_content_disabled');
      } else {
        jQuery('#jv-snapshotAndSendbtn').attr('class', 'unas_button_content');
      }
      //status table.
      var status = data.pool_status;
      //pool
      var config = status.config;
      var j = 0;
      var pstr = "";
      jQuery('#zpool_config').empty();
      for (var i = 0; i < config.length; i++) {
        //break the line into component
        pstr = config[i].line;
        pstr = pstr.trim().split(" "); //break into array
        pstr = pstr.filter(item => item); //delete "" elements.
        var iconLine = ""; //for replace in pool, remove in logs/cache/spare/
        var iconLine2 = ""; //for attach icon
        var iconLine3 = ""; //for detach icon
        var iconLine4 = ""; //for detach icon
        var Spaces = "";
        var sico = "";
        var iconName = "raid.png";
        var clickFun = "checkSaveSubmit();";
        var titleText = pstr[0];
        var by_path_Text = "";
        if (config[i].isDevice == 1 && config[i].poolComponent == 'pool') {
          iconName = 'HardDrive.png';
          clickFun = "replaceDevice(this)";
          titleText = UNAS._("Replace: ") + pstr[0];
          by_path_Text = config[i].name || '--';
          if (config[i].isMirrorDevice == 1) {
            iconName2 = 'attach.png';
            clickFun2 = "attachDevice(this)";
            titleText2 = "Attach to: " + pstr[0];
            iconLine2 = '<img src="/apps/zfs/images/' + iconName2 + '?v=0.0.1&" width="16" height="16" title="' + titleText2 + '" id="zpoolRAID=' + pstr[0] + '" name="' + pstr[0] + '" onClick="' + clickFun2 +
              '" style="margin-left: 0.8rem;" />';

            iconName3 = 'detach.png';
            clickFun3 = "detachDevice(this)";
            titleText3 = "Detach: " + pstr[0];
            iconLine3 = '<img src="/apps/zfs/images/' + iconName3 + '?v=0.0.1&" width="16" height="16" title="' + titleText3 + '" id="zpoolRAID=' + pstr[0] + '" name="' + pstr[0] + '" onClick="' + clickFun3 +
              '" style="margin-left:  0.8rem;"  />';

          }
        }
        if (config[i].leadCount > 0 && config[i].poolComponent != 'pool') {
          iconName = 'zpool_delete.png';
          if (config[i].poolComponent == "logs") {
            clickFun = "removeLogs(this)";
            titleText = "Remove Logs";
          }
          if (config[i].poolComponent == "spares") {
            clickFun = "removeSpare(this)";
            titleText = "Remove Spare";
          }
          if (config[i].poolComponent == "cache") {
            clickFun = "removeCache(this)";
            titleText = "Remove Cache";
          }
          if (config[i].poolComponent == "draid") {
            iconName = 'HardDrive.png';
            clickFun = "replaceDevice(this)";
            titleText = UNAS._("Replace: ") + pstr[0];
          }
          if (config[i].poolComponent == "dedup") {
            clickFun = "removeLogs(this)";
            titleText = UNAS._("Remove") + UNAS._("##$@zfs@$##Dedup##$@zfs@$##");
          }
          if (config[i].poolComponent == "special") {
            clickFun = "removeLogs(this)";
            titleText = UNAS._("Remove") + UNAS._("##$@zfs@$##Special##$@zfs@$##");
          }
        }
        let reg = new RegExp(/replacing-[\d]/);
        if (reg.test(config[i].name)) {
          clickFun = "";
        }
        if (config[i].leadCount == 0) { // pool name, logs, cache, spare; no icon need.
          iconLine = '<span class="unas_table_text"><div class="unas_checkbox"><input type="hidden" id="zfs_manager_checkextendpv' + pstr[0] + '" value="' + pstr[0] +
            '" onClick="checkSaveSubmit();" /><label for="zfs_manager_checkextendpv' + pstr[0] + '"></label></div></span>';
        }
        if (config[i].leadCount == 2) { // raid or stipe(device)
          iconLine = '<img src="/apps/zfs/images/' + iconName + '?v=0.0.1&" width="16" height="16" title="' + titleText + '" id="zpoolRAID=' + pstr[0] + '" name="' + pstr[0] + '" onClick="' + clickFun + '" />';
          Spaces = '&nbsp;&nbsp;&nbsp;&nbsp;';
          // sico = "<img class='sico' src='/apps/zfs/images/unas_icon_level.png'>"
          sico = "sico1";
          if (config[i].isDevice == 1 && config[i].poolComponent == 'pool') { //top level stripe, set iconLine2 for attach
            iconName2 = 'attach.png';
            clickFun2 = "attachDevice(this)";
            titleText2 = "Attach to: " + pstr[0];
            iconLine2 = '<img src="/apps/zfs/images/' + iconName2 + '?v=0.0.1&" width="16" height="16" title="' + titleText2 + '" id="zpoolRAID=' + pstr[0] + '" name="' + pstr[0] + '" onClick="' + clickFun2 +
              '" style="margin-left: 0.8rem;" />';

          }
        }
        if (config[i].leadCount == 4) { // device
          iconLine = '<img src="/apps/zfs/images/' + iconName + '?v=0.0.1&" width="16" height="16" title="' + titleText + '" id="zpoolRAID=' + pstr[0] + '" name="' + pstr[0] + '" onClick="' + clickFun + '" />';
          Spaces = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
          // sico = "<img class='sico' src='/apps/zfs/images/unas_icon_level.png'>"
          sico = "sico2";
        }
        if (typeof pstr[1] === 'undefined') {
          pstr[1] = "";
        }
        if (typeof pstr[2] === 'undefined') {
          pstr[2] = "";
        }
        if (typeof pstr[3] === 'undefined') {
          pstr[3] = "";
        }
        if (typeof pstr[4] === 'undefined') {
          pstr[4] = "";
        }
        //set the icon
        var tr = '<tr class=""><td class="' + sico + '" style="margin-left: 20px;padding-top:0.4rem;padding-bottom:0.4rem;" >' +
          '<div class="unas-flex flex-space-between">' +
          '<span class="unas_table_text" style="flex: 1;"><span>##$@zfs@$##NAME##$@zfs@$##</span><span>：</span><span>' + pstr[0] + '</span></span>' +
          '<span><span >##$@zfs@$##STATE##$@zfs@$##</span><span>：</span><span class="' + pstr[1] + '">' + pstr[1] + '</span></span>' +
          '</div>' +
          '<div class="unas-flex" style="justify-content: space-around;margin:0.28rem 0;" >' +
          '<span><span>##$@zfs@$##READ##$@zfs@$##</span><span>：</span><span>' + pstr[2] + '</span></span>' +
          '<span><span >##$@zfs@$##WRITE##$@zfs@$##</span><span>：</span><span >' + pstr[3] + '</span></span>' +
          '<span><span >##$@zfs@$##CKSUM##$@zfs@$##</span><span>：</span><span >' + pstr[4] + '</span></span>' +
          '</div>' +
          '<div class="unas-flex" style="justify-content: flex-end;" >' +
          iconLine + iconLine3 + iconLine4 +
          '</div>' +
          '</td></tr>'

        jQuery('#zpool_config').append(tr);

      }

      (function() {
        var rt = document.getElementById('zpool_config');
        var pageTranslators = window.top.UNAS.CreateNodesTranslators(rt.parentNode);
        var OnChangeLanguage = function(e) {
          for (var i = 0; i < pageTranslators.length; i++) {
            var node = pageTranslators[i].node;
            var p = pageTranslators[i].translateProperty;
            node[p] = window.top.UNAS._(pageTranslators[i].originalText);
          }
        };

        OnChangeLanguage();
        window.top.UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
        window.addEventListener("unload", function(e) {
          window.top.UNAS.Event.removeEvent('ChangeLanguage', OnChangeLanguage);
        }, false);
      })();

      var zpool_size = data.size;
      var zpoolfree_size = data.free;
      jQuery('#edit_zpoolname_size').html(formatSize(zpool_size));
      jQuery('#edit_zpoolname_free').html(formatSize(zpoolfree_size));
      jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(UNAS._(textStatus));
      jQuery('#zfs_manager_edit_zpool_waiting_content').attr("style", "display:none");
      jQuery('#zfs_manager_edit_zpool_waiting_logo').attr("style", "display:none");
    }
  });
}


var editpool_tasktimer = null;
var editpool_tasknamelist = [];

function zfseditpool_mission_alload() {
  clearTimeout(editpool_tasktimer);
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: '/wmi/',
      data: JSON.encode({
        "token": UToken,
        "cmd": 'zfsrep_mission_alload'
      }),
      type: "post",
      dataType: "json",
      contentType: 'application/json',
      timeout: 30000,
      success: function(res) {
        editpool_tasknamelist = [];
        if (res.err == 0) {
          var records = res.results.records || [];
          jQuery('#jv-editpoolrecvhost').empty();
          for (var i = 0; i < records.length; i++) {
            var tp_r = records[i];
            editpool_tasknamelist.push(tp_r.caption.toLowerCase());
            if ((edit_zpoolname != tp_r.pool) || (tp_r.action == 1 || tp_r.action == 3)) {
              continue;
            }
            var taskdom = zfsTemplateAppend('#jv-editpoolrecvhost', 'jvt-taskitem_editpool', 'jvt-taskitem_editpool-' + i);
            taskdom.find('.bdrtask-taskitem').data('taskinfo', tp_r);
            taskdom.find('.taskname').text(tp_r.caption || '--');
            taskdom.find('.dataset').text(tp_r.pool + '/' + tp_r.name);
            if (tp_r.host) {
              var path = tp_r.host + ':' + tp_r.port + '/' + tp_r.path;
              taskdom.find('.sendtask').text(path || '--');
            } else {
              taskdom.find('.sendtask').text(tp_r.path || '--');
            }


            var schedulestxt = [];
            if (tp_r.schedules.length) {
              for (var s = 0; s < tp_r.schedules.length; s++) {
                var t_s = tp_r.schedules[s];
                schedulestxt.push(zfseditpool_setSendTime(t_s));
              }
              taskdom.find('.schedule').html(schedulestxt[0]);
              var h = '';
              for (var j = 0; j < schedulestxt.length; j++) {
                h += '<li>' + schedulestxt[j] + '</li>';
              }
              taskdom.find('.jvc-sls').html(h);
              if (tp_r.schedules.length > 1) {
                taskdom.find('.schedulenub').text(tp_r.schedules.length).show();
              }

              taskdom.find('.schedulenub').on('mouseenter', function() {
                jQuery(this).parent().siblings('.schedulenublist').show();
              }).on('mouseleave', function() {
                jQuery(this).parent().siblings('.schedulenublist').hide();
              })

            } else {
              taskdom.find('.schedule').text('Nil');
              taskdom.find('.schedulenub').text(0).hide();
            }

            taskdom.find('.edit-taskicon').on('click', function() {
              var pnode = jQuery(this).closest('div.bdrtask-taskitem');
              var taskinfo = pnode.data('taskinfo');
              recvtaskFn_editpool(taskinfo, 'edit');
            });

            taskdom.find('.unas_icon_delete').on('click', function() {
              var pnode = jQuery(this).closest('div.bdrtask-taskitem');
              var taskinfo = pnode.data('taskinfo');
              unasConfirm({
                msg: UNAS._("Confirm to delete task") + '：' + taskinfo.caption + ' ?'
              }, function() {
                editpool_mission_remove(taskinfo.msnno);
              })
            });
          }
        }
        zfsTranslator('jv-editpoolrecvhost');
      },
      complete: function(xml) {
        resolve(xml);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
        reject(XMLHttpRequest);
      }
    })
  }).then(function() {
    zfseditpool_updatetaskrate();
  })
}

function zfseditpool_updatetaskrate() {
  clearTimeout(editpool_tasktimer);
  jQuery.ajax({
    url: '/wmi/',
    data: JSON.encode({
      "token": UToken,
      "cmd": 'zfsrep_mission_alload'
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      var taskdom = jQuery('#jv-editpoolrecvhost').children();
      if (res.err == 0) {
        var records = res.results.records || [];
        for (var j = 0; j < taskdom.length; j++) {
          var t_dom = jQuery(taskdom[j]).find('.bdrtask-taskitem');
          var taskinfo = t_dom.data('taskinfo');
          for (var i = 0; i < records.length; i++) {
            var t_s = records[i];
            if (t_s.caption == taskinfo.caption) {
              if (t_s.rate >= 0) {
                t_dom.find('.taskstate').text(UNAS._('##$@zfs@$##In Progress##$@zfs@$##'));
                t_dom.find('.taskstate').addClass('taskstate-0').removeClass('taskstate-2');
                t_dom.find('.tasknametitle').addClass('tasknametitle-0').removeClass('tasknametitle-1');
                t_dom.find('.edit-taskicon').addClass('layui-disabled');
                t_dom.find('.unas_icon_delete').addClass('layui-disabled');
                t_dom.find('.percent_txt').text(t_s.rate + '%');
                t_dom.find('.bar-w').css('width', t_s.rate + '%');
                t_dom.find('.jcv-speed').text(t_s.speed);
              } else {
                t_dom.find('.taskstate').text(UNAS._('##$@zfs@$##Completed##$@zfs@$##'));
                t_dom.find('.taskstate').addClass('taskstate-2').removeClass('taskstate-0');
                t_dom.find('.tasknametitle').addClass('tasknametitle-1').removeClass('tasknametitle-0');
                t_dom.find('.edit-taskicon').removeClass('layui-disabled');
                t_dom.find('.unas_icon_delete').removeClass('layui-disabled');
                if (t_s.finishedtime) {
                  t_dom.find('.percent_txt').text(t_s.finishedtime);
                } else {
                  t_dom.find('.percent_txt').text('');
                }
                t_dom.find('.bar-w').css('width', '0%');
                t_dom.find('.jcv-speed').text('--');
              }
            }
          }

        }


      }
    },
    complete: function(xml) {
      var taskdom = jQuery('#jv-editpoolrecvhost').children();
      var taskhosthidden = jQuery('#zfs_snapshot_replication_container').is(':hidden');
      if (taskdom.length && !taskhosthidden) {
        editpool_tasktimer = setTimeout(function() {
          zfseditpool_updatetaskrate();
        }, 2000);
      } else {
        clearTimeout(editpool_tasktimer);
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function zfseditpool_setSendTime(time) {
  var h = time['hours'];
  var m = time['minutes'];
  var w_i = time['weeks'];
  var days = time['days'];
  var weekArray = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
  var week = weekArray[w_i];
  var timetext = '';
  if (w_i) {
    timetext = '<span>' + week + '</span>' + ' ' + addTimeZero_zfseditpool(h) + ':' + addTimeZero_zfseditpool(m);
  } else if (days) {
    timetext = '<span>Monthly</span>' + ' ' + days + '<span>st</span>' + ' ' + addTimeZero_zfseditpool(h) + ':' + addTimeZero_zfseditpool(m);
  } else {
    timetext = '<span>Daily</span>' + ' ' + addTimeZero_zfseditpool(h) + ':' + addTimeZero_zfseditpool(m);
  }
  return timetext;
}

function addTimeZero_zfseditpool(num) {
  return num >= 10 ? num : '0' + num;
}

function editpool_mission_remove(n) {
  jQuery.ajax({
    url: '/wmi/',
    data: JSON.stringify({
      "token": UToken,
      "cmd": 'zfsrep_mission_remove',
      "params": {
        msnno: n
      }
    }),
    type: "post",
    dataType: "json",
    contentType: 'application/json',
    timeout: 30000,
    success: function(res) {
      zfseditpool_mission_alload();
    },
    complete: function(xml) {},
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    }
  })
}

function recvtaskFn_editpool(info = '', type = '') {
  var cwh = getClientWH();
  var title = UNAS._('##$@zfs@$##Create Recv task##$@zfs@$##');
  type && (title = UNAS._('##$@zfs@$##Edit Task##$@zfs@$##'));
  var createrecvtaskWin = new MUI.Modal({
    id: 'jv-createrecvtaskWindow',
    title: title,
    modal: true,
    modalOverlayClose: false,
    recvtask: {
      info: info,
      type: type
    },
    width: cwh.w,
    height: cwh.h,
    addClass: 'mobile-modal',
    type: 'modal2',
    contentURL: '/apps/zfs/m/zfs_recvtask.html?v=0.0.1&',
    onClose: function() {
      jQuery('#laydate_box').remove();
      recv_reqstatus = 0;
    }
  });
}

(function() {
  zfseditpool_mission_alload();
  jQuery('#scrub_set_hours').hide();
  jQuery('#zfs_scrub_weekly').hide();
  jQuery('#zfs_scrub_biweekly').hide();
  jQuery('#zfs_scrub_monthly').hide();
  jQuery("#scrub_text_weekly").hide();
  jQuery("#scrub_text_biweekly").hide();
  jQuery("#scrub_text_monthly").hide();

  var today = new Date();
  var date = today.getFullYear() + '-' + ('0' + (today.getMonth() + 1)).slice(-2) + '-' + ('0' + today.getDate()).slice(-2);
  var time = ('0' + today.getHours()).slice(-2) + ":" + ('0' + today.getMinutes()).slice(-2) + ":" + ('0' + today.getSeconds()).slice(-2);
  var dateTime = date + '_' + time;
  jQuery('#new_pool_snapshot_name').val(dateTime);

  jQuery('div[zfsitemtabid]').click(function() {
    var id = jQuery(this).attr('zfsitemtabid');
    jQuery('#zfs_manager_general_tab').attr('class', 'unas_tab');
    jQuery('#zfs_manager_pool_tab').attr('class', 'unas_tab');
    jQuery('#zfs_manager_expand_tab').attr('class', 'unas_tab');
    jQuery('#zfs_manager_advanced_tab').attr('class', 'unas_tab');
    jQuery(this).attr('class', 'unas_tab_sel');

    jQuery('#zfs_manager_zfs_container').attr('style', 'display:none');
    jQuery('#zfs_manager_advanced_container').attr('style', 'display:none');
    jQuery('#zfs_manager_general_container').attr('style', 'display:none');
    jQuery('#zfs_manager_pool_container').attr('style', 'display:none');
    jQuery('#zfs_manager_expand_container').attr('style', 'display:none');
    jQuery('#' + id).attr('style', 'display:block');
    if (id == "zfs_manager_expand_container") {
      getExtendPVsInfo();
    }
    if (id != "zfs_manager_dfs_container") {
      jQuery('#zfs_manager_zfs_container').attr('style', 'display:block');
    }
  });



  jQuery("#zfs_manager_create_zpool_selectall").click(function() {
    if (jQuery("#zfs_manager_create_zpool_selectall").prop("checked")) {
      jQuery("input[name='zfs_manager_checkextendpv']").prop("checked", true);
    } else {
      jQuery("input[name='zfs_manager_checkextendpv']").prop("checked", false);
    }
    checkSaveSubmit();
  });

  jQuery(".unas_table").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
  jQuery('#zfs_scrub_hours').empty();
  for (var i = 0; i < 24; i++) {
    var html = '<option value=' + i + '>' + i + ':00' + '</option>';
    jQuery('#zfs_scrub_hours').append(html);
  }
  jQuery('#create_zfsscrubtask_schedule').click(function() {
    if (jQuery('#create_zfsscrubtask_schedule').prop('checked') == true) {
      jQuery('#zfs_scrub_hours').prop('disabled', false);
      jQuery('#zfs_scrub_weekly').prop('disabled', false);
      jQuery('#zfs_scrub_biweekly').prop('disabled', false);
      jQuery('#zfs_scrub_monthly').prop('disabled', false);
      jQuery('#scrub_set_hours').show();
      jQuery('#zfs_scrub_weekly').show();
      jQuery('#zfs_scrub_biweekly').show();
      jQuery('#zfs_scrub_monthly').show();
      jQuery("#scrub_text_weekly").show();
      jQuery("#scrub_text_biweekly").show();
      jQuery("#scrub_text_monthly").show();
      jQuery(".scrubitem").show();
    } else {
      jQuery('#zfs_scrub_hours').prop('disabled', true);
      jQuery('#zfs_scrub_weekly').prop('disabled', true);
      jQuery('#zfs_scrub_biweekly').prop('disabled', true);
      jQuery('#zfs_scrub_monthly').prop('disabled', true);
      jQuery('#scrub_set_hours').hide();
      jQuery('#zfs_scrub_weekly').hide();
      jQuery('#zfs_scrub_biweekly').hide();
      jQuery('#zfs_scrub_monthly').hide();
      jQuery("#scrub_text_weekly").hide();
      jQuery("#scrub_text_biweekly").hide();
      jQuery("#scrub_text_monthly").hide();
      jQuery(".scrubitem").hide();
      SetScrub();
    }
  });

  jQuery('#create_zfsscrubtask_schedule').change(function(e) {
    jQuery("#zfs_set_scrub_button").attr("class", "unas_button_content").prop('disabled', !this.checked);
  })

  jQuery('input[name=create_zfs_scrub_schedule_type]').change(function(e) {
    jQuery("#zfs_set_scrub_button").attr("class", "unas_button_content").prop('disabled', false);
  })
  jQuery('#zfs_scrub_hours').change(function(e) {
    jQuery("#zfs_set_scrub_button").attr("class", "unas_button_content").prop('disabled', false);
  })

  jQuery("#zfs_set_scrub_button").attr("class", "unas_button_content_disabled").prop('disabled', true);

  GetZpoolInfo(zpoolname);

  jQuery("#select-snapshot-file").mCustomScrollbar({
    autoHideScrollbar: true,
    theme: "minimal-dark"
  });
})();
