<?php

require_once("/unas/apps/zfs/includes/settings.php");

$name = $argv[1];

function main(){
    global $name;
    $conf_file = sprintf(ZFS_FILE_RECEIVE_TMP, $name);
    if(file_exists($conf_file)){
        $job_set = json_decode(file_get_contents($conf_file), true);

        switch ($job_set["type"]){
            case "local":
                $target = $job_set["target"];
                $snap = $job_set["snap"];

                $receive_cmd = "zfs receive $target < '$snap'";
                exec($receive_cmd);
            default:
                break;
        }
        unlink($conf_file);
    }
}

main();
